/*
Copyright (c) 2010 - 2023, Nordic Semiconductor ASA All rights reserved.

SPDX-License-Identifier: BSD-3-Clause

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

3. Neither the name of Nordic Semiconductor ASA nor the names of its
   contributors may be used to endorse or promote products derived from this
   software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY, AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL NORDIC SEMICONDUCTOR ASA OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
 *
 * @file     /jenkins_workspace/workspace/SAG_Tools_nRFMDK_Build_master/_generated/Header/nrf9160.h
 * @brief    CMSIS HeaderFile
 * @version  1
 * @date     Thu Mar 23 14:54:55 2023
 * @note     Generated by SVDConv V3.3.44
 *           from File '/jenkins_workspace/workspace/SAG_Tools_nRFMDK_Build_master/source/files/svd/external/nrf9160.svd',
 *           last modified on Thu Mar 23 14:54:25 2023
 */


/** @addtogroup Nordic Semiconductor
  * @{
  */


/** @addtogroup nrf9160
  * @{
  */


#ifndef NRF9160_H
#define NRF9160_H

#ifdef __cplusplus
extern "C" {
#endif


/** @addtogroup Configuration_of_CMSIS
  * @{
  */



/* =========================================================================================================================== */
/* ================                                Interrupt Number Definition                                ================ */
/* =========================================================================================================================== */

typedef enum {
/* =======================================  ARM Cortex-M33 Specific Interrupt Numbers  ======================================= */
  Reset_IRQn                = -15,              /*!< -15  Reset Vector, invoked on Power up and warm reset                     */
  NonMaskableInt_IRQn       = -14,              /*!< -14  Non maskable Interrupt, cannot be stopped or preempted               */
  HardFault_IRQn            = -13,              /*!< -13  Hard Fault, all classes of Fault                                     */
  MemoryManagement_IRQn     = -12,              /*!< -12  Memory Management, MPU mismatch, including Access Violation
                                                     and No Match                                                              */
  BusFault_IRQn             = -11,              /*!< -11  Bus Fault, Pre-Fetch-, Memory Access Fault, other address/memory
                                                     related Fault                                                             */
  UsageFault_IRQn           = -10,              /*!< -10  Usage Fault, i.e. Undef Instruction, Illegal State Transition        */
  SecureFault_IRQn          =  -9,              /*!< -9 Secure Fault Handler                                                   */
  SVCall_IRQn               =  -5,              /*!< -5 System Service Call via SVC instruction                                */
  DebugMonitor_IRQn         =  -4,              /*!< -4 Debug Monitor                                                          */
  PendSV_IRQn               =  -2,              /*!< -2 Pendable request for system service                                    */
  SysTick_IRQn              =  -1,              /*!< -1 System Tick Timer                                                      */
/* ==========================================  nrf9160 Specific Interrupt Numbers  =========================================== */
  SPU_IRQn                  =   3,              /*!< 3  SPU                                                                    */
  CLOCK_POWER_IRQn          =   5,              /*!< 5  CLOCK_POWER                                                            */
  SPIM0_SPIS0_TWIM0_TWIS0_UARTE0_IRQn=   8,     /*!< 8  SPIM0_SPIS0_TWIM0_TWIS0_UARTE0                                         */
  SPIM1_SPIS1_TWIM1_TWIS1_UARTE1_IRQn=   9,     /*!< 9  SPIM1_SPIS1_TWIM1_TWIS1_UARTE1                                         */
  SPIM2_SPIS2_TWIM2_TWIS2_UARTE2_IRQn=  10,     /*!< 10 SPIM2_SPIS2_TWIM2_TWIS2_UARTE2                                         */
  SPIM3_SPIS3_TWIM3_TWIS3_UARTE3_IRQn=  11,     /*!< 11 SPIM3_SPIS3_TWIM3_TWIS3_UARTE3                                         */
  GPIOTE0_IRQn              =  13,              /*!< 13 GPIOTE0                                                                */
  SAADC_IRQn                =  14,              /*!< 14 SAADC                                                                  */
  TIMER0_IRQn               =  15,              /*!< 15 TIMER0                                                                 */
  TIMER1_IRQn               =  16,              /*!< 16 TIMER1                                                                 */
  TIMER2_IRQn               =  17,              /*!< 17 TIMER2                                                                 */
  RTC0_IRQn                 =  20,              /*!< 20 RTC0                                                                   */
  RTC1_IRQn                 =  21,              /*!< 21 RTC1                                                                   */
  WDT_IRQn                  =  24,              /*!< 24 WDT                                                                    */
  EGU0_IRQn                 =  27,              /*!< 27 EGU0                                                                   */
  EGU1_IRQn                 =  28,              /*!< 28 EGU1                                                                   */
  EGU2_IRQn                 =  29,              /*!< 29 EGU2                                                                   */
  EGU3_IRQn                 =  30,              /*!< 30 EGU3                                                                   */
  EGU4_IRQn                 =  31,              /*!< 31 EGU4                                                                   */
  EGU5_IRQn                 =  32,              /*!< 32 EGU5                                                                   */
  PWM0_IRQn                 =  33,              /*!< 33 PWM0                                                                   */
  PWM1_IRQn                 =  34,              /*!< 34 PWM1                                                                   */
  PWM2_IRQn                 =  35,              /*!< 35 PWM2                                                                   */
  PWM3_IRQn                 =  36,              /*!< 36 PWM3                                                                   */
  PDM_IRQn                  =  38,              /*!< 38 PDM                                                                    */
  I2S_IRQn                  =  40,              /*!< 40 I2S                                                                    */
  IPC_IRQn                  =  42,              /*!< 42 IPC                                                                    */
  FPU_IRQn                  =  44,              /*!< 44 FPU                                                                    */
  GPIOTE1_IRQn              =  49,              /*!< 49 GPIOTE1                                                                */
  KMU_IRQn                  =  57,              /*!< 57 KMU                                                                    */
  CRYPTOCELL_IRQn           =  64               /*!< 64 CRYPTOCELL                                                             */
} IRQn_Type;



/* =========================================================================================================================== */
/* ================                           Processor and Core Peripheral Section                           ================ */
/* =========================================================================================================================== */

/* ==========================  Configuration of the ARM Cortex-M33 Processor and Core Peripherals  =========================== */
#define __CM33_REV                 0x0004U      /*!< CM33 Core Revision                                                        */
#define __INTERRUPTS_MAX                   240        /*!< Top interrupt number                                                      */
#define __DSP_PRESENT                  1        /*!< DSP present or not                                                        */
#define __NVIC_PRIO_BITS               3        /*!< Number of Bits used for Priority Levels                                   */
#define __Vendor_SysTickConfig         0        /*!< Set to 1 if different SysTick Config is used                              */
#define __VTOR_PRESENT                 1        /*!< Set to 1 if CPU supports Vector Table Offset Register                     */
#define __MPU_PRESENT                  1        /*!< MPU present                                                               */
#define __FPU_PRESENT                  1        /*!< FPU present                                                               */
#define __FPU_DP                       0        /*!< Double Precision FPU                                                      */
#define __SAUREGION_PRESENT            0        /*!< SAU region present                                                        */


/** @} */ /* End of group Configuration_of_CMSIS */

#include "core_cm33.h"                          /*!< ARM Cortex-M33 processor and core peripherals                             */
#include "system_nrf9160.h"                     /*!< nrf9160 System                                                            */

#ifndef __IM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __IM   __I
#endif
#ifndef __OM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __OM   __O
#endif
#ifndef __IOM                                   /*!< Fallback for older CMSIS versions                                         */
  #define __IOM  __IO
#endif


/* =========================================================================================================================== */
/* ================                              Device Specific Cluster Section                              ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_clusters
  * @{
  */


/**
  * @brief FICR_SIPINFO [SIPINFO] (SIP-specific device info)
  */
typedef struct {
  __IM  uint32_t  PARTNO;                       /*!< SIP part number                                                           */
  __IM  uint8_t   HWREVISION[4];                /*!< Description collection: SIP hardware revision, encoded in ASCII,
                                                     ex B0A or B1A                                                             */
  __IM  uint8_t   VARIANT[4];                   /*!< Description collection: SIP VARIANT, encoded in ASCII, ex SIAA,
                                                     SIBA or SICA                                                              */
} FICR_SIPINFO_Type;                            /*!< Size = 12 (0xc)                                                           */


/**
  * @brief FICR_INFO [INFO] (Device info)
  */
typedef struct {
  __IM  uint32_t  RESERVED;
  __IM  uint32_t  DEVICEID[2];                  /*!< Description collection: Device identifier                                 */
  __IM  uint32_t  PART;                         /*!< Part code                                                                 */
  __IM  uint32_t  VARIANT;                      /*!< Part Variant, Hardware version and Production configuration               */
  __IM  uint32_t  PACKAGE;                      /*!< Package option                                                            */
  __IM  uint32_t  RAM;                          /*!< RAM variant                                                               */
  __IM  uint32_t  FLASH;                        /*!< Flash variant                                                             */
  __IM  uint32_t  CODEPAGESIZE;                 /*!< Code memory page size                                                     */
  __IM  uint32_t  CODESIZE;                     /*!< Code memory size                                                          */
  __IM  uint32_t  DEVICETYPE;                   /*!< Device type                                                               */
} FICR_INFO_Type;                               /*!< Size = 44 (0x2c)                                                          */


/**
  * @brief FICR_TRIMCNF [TRIMCNF] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  ADDR;                         /*!< Description cluster: Address                                              */
  __IM  uint32_t  DATA;                         /*!< Description cluster: Data                                                 */
} FICR_TRIMCNF_Type;                            /*!< Size = 8 (0x8)                                                            */


/**
  * @brief FICR_TRNG90B [TRNG90B] (NIST800-90B RNG calibration data)
  */
typedef struct {
  __IM  uint32_t  BYTES;                        /*!< Amount of bytes for the required entropy bits                             */
  __IM  uint32_t  RCCUTOFF;                     /*!< Repetition counter cutoff                                                 */
  __IM  uint32_t  APCUTOFF;                     /*!< Adaptive proportion cutoff                                                */
  __IM  uint32_t  STARTUP;                      /*!< Amount of bytes for the startup tests                                     */
  __IM  uint32_t  ROSC1;                        /*!< Sample count for ring oscillator 1                                        */
  __IM  uint32_t  ROSC2;                        /*!< Sample count for ring oscillator 2                                        */
  __IM  uint32_t  ROSC3;                        /*!< Sample count for ring oscillator 3                                        */
  __IM  uint32_t  ROSC4;                        /*!< Sample count for ring oscillator 4                                        */
} FICR_TRNG90B_Type;                            /*!< Size = 32 (0x20)                                                          */


/**
  * @brief UICR_KEYSLOT_CONFIG [CONFIG] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  DEST;                         /*!< Description cluster: Destination address where content of the
                                                     key value registers (KEYSLOT.KEYn.VALUE[0-3]) will be pushed
                                                     by KMU. Note that this address must match that of a peripherals
                                                     APB mapped write-only key registers, else the KMU can push
                                                     this key value into an address range which the CPU can
                                                     potentially read.                                                         */
  __IOM uint32_t  PERM;                         /*!< Description cluster: Define permissions for the key slot. Bits
                                                     0-15 and 16-31 can only be written when equal to 0xFFFF.                  */
} UICR_KEYSLOT_CONFIG_Type;                     /*!< Size = 8 (0x8)                                                            */


/**
  * @brief UICR_KEYSLOT_KEY [KEY] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  VALUE[4];                     /*!< Description collection: Define bits [31+o*32:0+o*32] of value
                                                     assigned to KMU key slot.                                                 */
} UICR_KEYSLOT_KEY_Type;                        /*!< Size = 16 (0x10)                                                          */


/**
  * @brief UICR_KEYSLOT [KEYSLOT] (Unspecified)
  */
typedef struct {
  __IOM UICR_KEYSLOT_CONFIG_Type CONFIG[128];   /*!< Unspecified                                                               */
  __IOM UICR_KEYSLOT_KEY_Type KEY[128];         /*!< Unspecified                                                               */
} UICR_KEYSLOT_Type;                            /*!< Size = 3072 (0xc00)                                                       */


/**
  * @brief TAD_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  TRACECLK;                     /*!< Pin configuration for TRACECLK                                            */
  __IOM uint32_t  TRACEDATA0;                   /*!< Pin configuration for TRACEDATA[0]                                        */
  __IOM uint32_t  TRACEDATA1;                   /*!< Pin configuration for TRACEDATA[1]                                        */
  __IOM uint32_t  TRACEDATA2;                   /*!< Pin configuration for TRACEDATA[2]                                        */
  __IOM uint32_t  TRACEDATA3;                   /*!< Pin configuration for TRACEDATA[3]                                        */
} TAD_PSEL_Type;                                /*!< Size = 20 (0x14)                                                          */


/**
  * @brief SPU_EXTDOMAIN [EXTDOMAIN] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PERM;                         /*!< Description cluster: Access for bus access generated from the
                                                     external domain n List capabilities of the external domain
                                                     n                                                                         */
} SPU_EXTDOMAIN_Type;                           /*!< Size = 4 (0x4)                                                            */


/**
  * @brief SPU_DPPI [DPPI] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PERM;                         /*!< Description cluster: Select between secure and non-secure attribute
                                                     for the DPPI channels.                                                    */
  __IOM uint32_t  LOCK;                         /*!< Description cluster: Prevent further modification of the corresponding
                                                     PERM register                                                             */
} SPU_DPPI_Type;                                /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPU_GPIOPORT [GPIOPORT] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PERM;                         /*!< Description cluster: Select between secure and non-secure attribute
                                                     for pins 0 to 31 of port n.                                               */
  __IOM uint32_t  LOCK;                         /*!< Description cluster: Prevent further modification of the corresponding
                                                     PERM register                                                             */
} SPU_GPIOPORT_Type;                            /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPU_FLASHNSC [FLASHNSC] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  REGION;                       /*!< Description cluster: Define which flash region can contain the
                                                     non-secure callable (NSC) region n                                        */
  __IOM uint32_t  SIZE;                         /*!< Description cluster: Define the size of the non-secure callable
                                                     (NSC) region n                                                            */
} SPU_FLASHNSC_Type;                            /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPU_RAMNSC [RAMNSC] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  REGION;                       /*!< Description cluster: Define which RAM region can contain the
                                                     non-secure callable (NSC) region n                                        */
  __IOM uint32_t  SIZE;                         /*!< Description cluster: Define the size of the non-secure callable
                                                     (NSC) region n                                                            */
} SPU_RAMNSC_Type;                              /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPU_FLASHREGION [FLASHREGION] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PERM;                         /*!< Description cluster: Access permissions for flash region n                */
} SPU_FLASHREGION_Type;                         /*!< Size = 4 (0x4)                                                            */


/**
  * @brief SPU_RAMREGION [RAMREGION] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PERM;                         /*!< Description cluster: Access permissions for RAM region n                  */
} SPU_RAMREGION_Type;                           /*!< Size = 4 (0x4)                                                            */


/**
  * @brief SPU_PERIPHID [PERIPHID] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PERM;                         /*!< Description cluster: List capabilities and access permissions
                                                     for the peripheral with ID n                                              */
} SPU_PERIPHID_Type;                            /*!< Size = 4 (0x4)                                                            */


/**
  * @brief POWER_LTEMODEM [LTEMODEM] (LTE Modem)
  */
typedef struct {
  __IOM uint32_t  STARTN;                       /*!< Start LTE modem                                                           */
  __IOM uint32_t  FORCEOFF;                     /*!< Force off LTE modem                                                       */
} POWER_LTEMODEM_Type;                          /*!< Size = 8 (0x8)                                                            */


/**
  * @brief CTRLAPPERI_MAILBOX [MAILBOX] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  RXDATA;                       /*!< Data sent from the debugger to the CPU.                                   */
  __IM  uint32_t  RXSTATUS;                     /*!< This register shows a status that indicates if data sent from
                                                     the debugger to the CPU has been read.                                    */
  __IM  uint32_t  RESERVED[30];
  __IOM uint32_t  TXDATA;                       /*!< Data sent from the CPU to the debugger.                                   */
  __IM  uint32_t  TXSTATUS;                     /*!< This register shows a status that indicates if the data sent
                                                     from the CPU to the debugger has been read.                               */
} CTRLAPPERI_MAILBOX_Type;                      /*!< Size = 136 (0x88)                                                         */


/**
  * @brief CTRLAPPERI_ERASEPROTECT [ERASEPROTECT] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  LOCK;                         /*!< This register locks the ERASEPROTECT.DISABLE register from being
                                                     written until next reset.                                                 */
  __IOM uint32_t  DISABLE;                      /*!< This register disables the ERASEPROTECT register and performs
                                                     an ERASEALL operation.                                                    */
} CTRLAPPERI_ERASEPROTECT_Type;                 /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPIM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCK;                          /*!< Pin select for SCK                                                        */
  __IOM uint32_t  MOSI;                         /*!< Pin select for MOSI signal                                                */
  __IOM uint32_t  MISO;                         /*!< Pin select for MISO signal                                                */
} SPIM_PSEL_Type;                               /*!< Size = 12 (0xc)                                                           */


/**
  * @brief SPIM_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIM_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIM_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIM_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIS_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCK;                          /*!< Pin select for SCK                                                        */
  __IOM uint32_t  MISO;                         /*!< Pin select for MISO signal                                                */
  __IOM uint32_t  MOSI;                         /*!< Pin select for MOSI signal                                                */
  __IOM uint32_t  CSN;                          /*!< Pin select for CSN signal                                                 */
} SPIS_PSEL_Type;                               /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIS_RXD [RXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< RXD data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes received in last granted transaction                      */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIS_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIS_TXD [TXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< TXD data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transmitted in last granted transaction                   */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIS_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCL;                          /*!< Pin select for SCL signal                                                 */
  __IOM uint32_t  SDA;                          /*!< Pin select for SDA signal                                                 */
} TWIM_PSEL_Type;                               /*!< Size = 8 (0x8)                                                            */


/**
  * @brief TWIM_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIM_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIM_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIM_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIS_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCL;                          /*!< Pin select for SCL signal                                                 */
  __IOM uint32_t  SDA;                          /*!< Pin select for SDA signal                                                 */
} TWIS_PSEL_Type;                               /*!< Size = 8 (0x8)                                                            */


/**
  * @brief TWIS_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< RXD Data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in RXD buffer                                     */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last RXD transaction                   */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIS_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIS_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< TXD Data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in TXD buffer                                     */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last TXD transaction                   */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIS_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief UARTE_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  RTS;                          /*!< Pin select for RTS signal                                                 */
  __IOM uint32_t  TXD;                          /*!< Pin select for TXD signal                                                 */
  __IOM uint32_t  CTS;                          /*!< Pin select for CTS signal                                                 */
  __IOM uint32_t  RXD;                          /*!< Pin select for RXD signal                                                 */
} UARTE_PSEL_Type;                              /*!< Size = 16 (0x10)                                                          */


/**
  * @brief UARTE_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
} UARTE_RXD_Type;                               /*!< Size = 12 (0xc)                                                           */


/**
  * @brief UARTE_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
} UARTE_TXD_Type;                               /*!< Size = 12 (0xc)                                                           */


/**
  * @brief SAADC_EVENTS_CH [EVENTS_CH] (Peripheral events.)
  */
typedef struct {
  __IOM uint32_t  LIMITH;                       /*!< Description cluster: Last results is equal or above CH[n].LIMIT.HIGH      */
  __IOM uint32_t  LIMITL;                       /*!< Description cluster: Last results is equal or below CH[n].LIMIT.LOW       */
} SAADC_EVENTS_CH_Type;                         /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SAADC_PUBLISH_CH [PUBLISH_CH] (Publish configuration for events)
  */
typedef struct {
  __IOM uint32_t  LIMITH;                       /*!< Description cluster: Publish configuration for event CH[n].LIMITH         */
  __IOM uint32_t  LIMITL;                       /*!< Description cluster: Publish configuration for event CH[n].LIMITL         */
} SAADC_PUBLISH_CH_Type;                        /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SAADC_CH [CH] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PSELP;                        /*!< Description cluster: Input positive pin selection for CH[n]               */
  __IOM uint32_t  PSELN;                        /*!< Description cluster: Input negative pin selection for CH[n]               */
  __IOM uint32_t  CONFIG;                       /*!< Description cluster: Input configuration for CH[n]                        */
  __IOM uint32_t  LIMIT;                        /*!< Description cluster: High/low limits for event monitoring a
                                                     channel                                                                   */
} SAADC_CH_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SAADC_RESULT [RESULT] (RESULT EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of buffer words to transfer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of buffer words transferred since last START                       */
} SAADC_RESULT_Type;                            /*!< Size = 12 (0xc)                                                           */


/**
  * @brief DPPIC_TASKS_CHG [TASKS_CHG] (Channel group tasks)
  */
typedef struct {
  __OM  uint32_t  EN;                           /*!< Description cluster: Enable channel group n                               */
  __OM  uint32_t  DIS;                          /*!< Description cluster: Disable channel group n                              */
} DPPIC_TASKS_CHG_Type;                         /*!< Size = 8 (0x8)                                                            */


/**
  * @brief DPPIC_SUBSCRIBE_CHG [SUBSCRIBE_CHG] (Subscribe configuration for tasks)
  */
typedef struct {
  __IOM uint32_t  EN;                           /*!< Description cluster: Subscribe configuration for task CHG[n].EN           */
  __IOM uint32_t  DIS;                          /*!< Description cluster: Subscribe configuration for task CHG[n].DIS          */
} DPPIC_SUBSCRIBE_CHG_Type;                     /*!< Size = 8 (0x8)                                                            */


/**
  * @brief PWM_SEQ [SEQ] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Description cluster: Beginning address in RAM of this sequence            */
  __IOM uint32_t  CNT;                          /*!< Description cluster: Number of values (duty cycles) in this
                                                     sequence                                                                  */
  __IOM uint32_t  REFRESH;                      /*!< Description cluster: Number of additional PWM periods between
                                                     samples loaded into compare register                                      */
  __IOM uint32_t  ENDDELAY;                     /*!< Description cluster: Time added after the sequence                        */
  __IM  uint32_t  RESERVED[4];
} PWM_SEQ_Type;                                 /*!< Size = 32 (0x20)                                                          */


/**
  * @brief PWM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  OUT[4];                       /*!< Description collection: Output pin select for PWM channel n               */
} PWM_PSEL_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief PDM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  CLK;                          /*!< Pin number configuration for PDM CLK signal                               */
  __IOM uint32_t  DIN;                          /*!< Pin number configuration for PDM DIN signal                               */
} PDM_PSEL_Type;                                /*!< Size = 8 (0x8)                                                            */


/**
  * @brief PDM_SAMPLE [SAMPLE] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< RAM address pointer to write samples to with EasyDMA                      */
  __IOM uint32_t  MAXCNT;                       /*!< Number of samples to allocate memory for in EasyDMA mode                  */
} PDM_SAMPLE_Type;                              /*!< Size = 8 (0x8)                                                            */


/**
  * @brief I2S_CONFIG [CONFIG] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  MODE;                         /*!< I2S mode.                                                                 */
  __IOM uint32_t  RXEN;                         /*!< Reception (RX) enable.                                                    */
  __IOM uint32_t  TXEN;                         /*!< Transmission (TX) enable.                                                 */
  __IOM uint32_t  MCKEN;                        /*!< Master clock generator enable.                                            */
  __IOM uint32_t  MCKFREQ;                      /*!< Master clock generator frequency.                                         */
  __IOM uint32_t  RATIO;                        /*!< MCK / LRCK ratio.                                                         */
  __IOM uint32_t  SWIDTH;                       /*!< Sample width.                                                             */
  __IOM uint32_t  ALIGN;                        /*!< Alignment of sample within a frame.                                       */
  __IOM uint32_t  FORMAT;                       /*!< Frame format.                                                             */
  __IOM uint32_t  CHANNELS;                     /*!< Enable channels.                                                          */
} I2S_CONFIG_Type;                              /*!< Size = 40 (0x28)                                                          */


/**
  * @brief I2S_RXD [RXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Receive buffer RAM start address.                                         */
} I2S_RXD_Type;                                 /*!< Size = 4 (0x4)                                                            */


/**
  * @brief I2S_TXD [TXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Transmit buffer RAM start address.                                        */
} I2S_TXD_Type;                                 /*!< Size = 4 (0x4)                                                            */


/**
  * @brief I2S_RXTXD [RXTXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  MAXCNT;                       /*!< Size of RXD and TXD buffers.                                              */
} I2S_RXTXD_Type;                               /*!< Size = 4 (0x4)                                                            */


/**
  * @brief I2S_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  MCK;                          /*!< Pin select for MCK signal.                                                */
  __IOM uint32_t  SCK;                          /*!< Pin select for SCK signal.                                                */
  __IOM uint32_t  LRCK;                         /*!< Pin select for LRCK signal.                                               */
  __IOM uint32_t  SDIN;                         /*!< Pin select for SDIN signal.                                               */
  __IOM uint32_t  SDOUT;                        /*!< Pin select for SDOUT signal.                                              */
} I2S_PSEL_Type;                                /*!< Size = 20 (0x14)                                                          */


/**
  * @brief VMC_RAM [RAM] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  POWER;                        /*!< Description cluster: RAMn power control register                          */
  __OM  uint32_t  POWERSET;                     /*!< Description cluster: RAMn power control set register                      */
  __OM  uint32_t  POWERCLR;                     /*!< Description cluster: RAMn power control clear register                    */
  __IM  uint32_t  RESERVED;
} VMC_RAM_Type;                                 /*!< Size = 16 (0x10)                                                          */


/** @} */ /* End of group Device_Peripheral_clusters */


/* =========================================================================================================================== */
/* ================                            Device Specific Peripheral Section                             ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                          FICR_S                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Factory Information Configuration Registers (FICR_S)
  */

typedef struct {                                /*!< FICR_S Structure                                                          */
  __IM  uint32_t  RESERVED[80];
  __IOM FICR_SIPINFO_Type SIPINFO;              /*!< SIP-specific device info                                                  */
  __IM  uint32_t  RESERVED1[45];
  __IOM FICR_INFO_Type INFO;                    /*!< Device info                                                               */
  __IM  uint32_t  RESERVED2[53];
  __IOM FICR_TRIMCNF_Type TRIMCNF[256];         /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED3[64];
  __IOM FICR_TRNG90B_Type TRNG90B;              /*!< NIST800-90B RNG calibration data                                          */
} NRF_FICR_Type;                                /*!< Size = 3104 (0xc20)                                                       */



/* =========================================================================================================================== */
/* ================                                          UICR_S                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief User information configuration registers User information configuration registers (UICR_S)
  */

typedef struct {                                /*!< UICR_S Structure                                                          */
  __IOM uint32_t  APPROTECT;                    /*!< Access port protection                                                    */
  __IM  uint32_t  RESERVED[4];
  __IOM uint32_t  XOSC32M;                      /*!< Oscillator control                                                        */
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  HFXOSRC;                      /*!< HFXO clock source selection                                               */
  __IOM uint32_t  HFXOCNT;                      /*!< HFXO startup counter                                                      */
  __IOM uint32_t  APPNVMCPOFGUARD;              /*!< Enable blocking NVM WRITE and aborting NVM ERASE for Application
                                                     NVM in POFWARN condition .                                                */
  __IM  uint32_t  RESERVED2;
  __IOM uint32_t  SECUREAPPROTECT;              /*!< Secure access port protection                                             */
  __IOM uint32_t  ERASEPROTECT;                 /*!< Erase protection                                                          */
  __IM  uint32_t  RESERVED3[53];
  __IOM uint32_t  OTP[190];                     /*!< Description collection: One time programmable memory                      */
  __IOM UICR_KEYSLOT_Type KEYSLOT;              /*!< Unspecified                                                               */
} NRF_UICR_Type;                                /*!< Size = 4096 (0x1000)                                                      */



/* =========================================================================================================================== */
/* ================                                           TAD_S                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Trace and debug control (TAD_S)
  */

typedef struct {                                /*!< TAD_S Structure                                                           */
  __OM  uint32_t  TASKS_CLOCKSTART;             /*!< Start all trace and debug clocks.                                         */
  __OM  uint32_t  TASKS_CLOCKSTOP;              /*!< Stop all trace and debug clocks.                                          */
  __IM  uint32_t  RESERVED[318];
  __IOM uint32_t  ENABLE;                       /*!< Enable debug domain and aquire selected GPIOs                             */
  __IOM TAD_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
  __IOM uint32_t  TRACEPORTSPEED;               /*!< Clocking options for the Trace Port debug interface Reset behavior
                                                     is the same as debug components                                           */
} NRF_TAD_Type;                                 /*!< Size = 1308 (0x51c)                                                       */



/* =========================================================================================================================== */
/* ================                                           SPU_S                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief System protection unit (SPU_S)
  */

typedef struct {                                /*!< SPU_S Structure                                                           */
  __IM  uint32_t  RESERVED[64];
  __IOM uint32_t  EVENTS_RAMACCERR;             /*!< A security violation has been detected for the RAM memory space           */
  __IOM uint32_t  EVENTS_FLASHACCERR;           /*!< A security violation has been detected for the flash memory
                                                     space                                                                     */
  __IOM uint32_t  EVENTS_PERIPHACCERR;          /*!< A security violation has been detected on one or several peripherals      */
  __IM  uint32_t  RESERVED1[29];
  __IOM uint32_t  PUBLISH_RAMACCERR;            /*!< Publish configuration for event RAMACCERR                                 */
  __IOM uint32_t  PUBLISH_FLASHACCERR;          /*!< Publish configuration for event FLASHACCERR                               */
  __IOM uint32_t  PUBLISH_PERIPHACCERR;         /*!< Publish configuration for event PERIPHACCERR                              */
  __IM  uint32_t  RESERVED2[93];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED3[61];
  __IM  uint32_t  CAP;                          /*!< Show implemented features for the current device                          */
  __IM  uint32_t  RESERVED4[15];
  __IOM SPU_EXTDOMAIN_Type EXTDOMAIN[1];        /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED5[15];
  __IOM SPU_DPPI_Type DPPI[1];                  /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED6[14];
  __IOM SPU_GPIOPORT_Type GPIOPORT[1];          /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED7[14];
  __IOM SPU_FLASHNSC_Type FLASHNSC[2];          /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED8[12];
  __IOM SPU_RAMNSC_Type RAMNSC[2];              /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED9[44];
  __IOM SPU_FLASHREGION_Type FLASHREGION[32];   /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED10[32];
  __IOM SPU_RAMREGION_Type RAMREGION[32];       /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED11[32];
  __IOM SPU_PERIPHID_Type PERIPHID[67];         /*!< Unspecified                                                               */
} NRF_SPU_Type;                                 /*!< Size = 2316 (0x90c)                                                       */



/* =========================================================================================================================== */
/* ================                                       REGULATORS_NS                                       ================ */
/* =========================================================================================================================== */


/**
  * @brief Voltage regulators control 0 (REGULATORS_NS)
  */

typedef struct {                                /*!< REGULATORS_NS Structure                                                   */
  __IM  uint32_t  RESERVED[320];
  __OM  uint32_t  SYSTEMOFF;                    /*!< System OFF register                                                       */
  __IM  uint32_t  RESERVED1[4];
  __IOM uint32_t  EXTPOFCON;                    /*!< External power failure warning configuration                              */
  __IM  uint32_t  RESERVED2[24];
  __IOM uint32_t  DCDCEN;                       /*!< Enable DC/DC mode of the main voltage regulator.                          */
} NRF_REGULATORS_Type;                          /*!< Size = 1404 (0x57c)                                                       */



/* =========================================================================================================================== */
/* ================                                         CLOCK_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Clock management 0 (CLOCK_NS)
  */

typedef struct {                                /*!< CLOCK_NS Structure                                                        */
  __OM  uint32_t  TASKS_HFCLKSTART;             /*!< Start HFCLK source                                                        */
  __OM  uint32_t  TASKS_HFCLKSTOP;              /*!< Stop HFCLK source                                                         */
  __OM  uint32_t  TASKS_LFCLKSTART;             /*!< Start LFCLK source                                                        */
  __OM  uint32_t  TASKS_LFCLKSTOP;              /*!< Stop LFCLK source                                                         */
  __IM  uint32_t  RESERVED[28];
  __IOM uint32_t  SUBSCRIBE_HFCLKSTART;         /*!< Subscribe configuration for task HFCLKSTART                               */
  __IOM uint32_t  SUBSCRIBE_HFCLKSTOP;          /*!< Subscribe configuration for task HFCLKSTOP                                */
  __IOM uint32_t  SUBSCRIBE_LFCLKSTART;         /*!< Subscribe configuration for task LFCLKSTART                               */
  __IOM uint32_t  SUBSCRIBE_LFCLKSTOP;          /*!< Subscribe configuration for task LFCLKSTOP                                */
  __IM  uint32_t  RESERVED1[28];
  __IOM uint32_t  EVENTS_HFCLKSTARTED;          /*!< HFCLK oscillator started                                                  */
  __IOM uint32_t  EVENTS_LFCLKSTARTED;          /*!< LFCLK started                                                             */
  __IM  uint32_t  RESERVED2[30];
  __IOM uint32_t  PUBLISH_HFCLKSTARTED;         /*!< Publish configuration for event HFCLKSTARTED                              */
  __IOM uint32_t  PUBLISH_LFCLKSTARTED;         /*!< Publish configuration for event LFCLKSTARTED                              */
  __IM  uint32_t  RESERVED3[94];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  INTPEND;                      /*!< Pending interrupts                                                        */
  __IM  uint32_t  RESERVED4[62];
  __IM  uint32_t  HFCLKRUN;                     /*!< Status indicating that HFCLKSTART task has been triggered                 */
  __IM  uint32_t  HFCLKSTAT;                    /*!< The register shows if HFXO has been requested by triggering
                                                     HFCLKSTART task and if it has been started (STATE)                        */
  __IM  uint32_t  RESERVED5;
  __IM  uint32_t  LFCLKRUN;                     /*!< Status indicating that LFCLKSTART task has been triggered                 */
  __IM  uint32_t  LFCLKSTAT;                    /*!< The register shows which LFCLK source has been requested (SRC)
                                                     when triggering LFCLKSTART task and if the source has been
                                                     started (STATE)                                                           */
  __IM  uint32_t  LFCLKSRCCOPY;                 /*!< Copy of LFCLKSRC register, set after LFCLKSTART task has been
                                                     triggered                                                                 */
  __IM  uint32_t  RESERVED6[62];
  __IOM uint32_t  LFCLKSRC;                     /*!< Clock source for the LFCLK. LFCLKSTART task starts starts a
                                                     clock source selected with this register.                                 */
} NRF_CLOCK_Type;                               /*!< Size = 1308 (0x51c)                                                       */



/* =========================================================================================================================== */
/* ================                                         POWER_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Power control 0 (POWER_NS)
  */

typedef struct {                                /*!< POWER_NS Structure                                                        */
  __IM  uint32_t  RESERVED[30];
  __OM  uint32_t  TASKS_CONSTLAT;               /*!< Enable constant latency mode.                                             */
  __OM  uint32_t  TASKS_LOWPWR;                 /*!< Enable low power mode (variable latency)                                  */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  SUBSCRIBE_CONSTLAT;           /*!< Subscribe configuration for task CONSTLAT                                 */
  __IOM uint32_t  SUBSCRIBE_LOWPWR;             /*!< Subscribe configuration for task LOWPWR                                   */
  __IM  uint32_t  RESERVED2[2];
  __IOM uint32_t  EVENTS_POFWARN;               /*!< Power failure warning                                                     */
  __IM  uint32_t  RESERVED3[2];
  __IOM uint32_t  EVENTS_SLEEPENTER;            /*!< CPU entered WFI/WFE sleep                                                 */
  __IOM uint32_t  EVENTS_SLEEPEXIT;             /*!< CPU exited WFI/WFE sleep                                                  */
  __IM  uint32_t  RESERVED4[27];
  __IOM uint32_t  PUBLISH_POFWARN;              /*!< Publish configuration for event POFWARN                                   */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  PUBLISH_SLEEPENTER;           /*!< Publish configuration for event SLEEPENTER                                */
  __IOM uint32_t  PUBLISH_SLEEPEXIT;            /*!< Publish configuration for event SLEEPEXIT                                 */
  __IM  uint32_t  RESERVED6[89];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED7[61];
  __IOM uint32_t  RESETREAS;                    /*!< Reset reason                                                              */
  __IM  uint32_t  RESERVED8[15];
  __IM  uint32_t  POWERSTATUS;                  /*!< Modem domain power status                                                 */
  __IM  uint32_t  RESERVED9[54];
  __IOM uint32_t  GPREGRET[2];                  /*!< Description collection: General purpose retention register                */
  __IM  uint32_t  RESERVED10[59];
  __IOM POWER_LTEMODEM_Type LTEMODEM;           /*!< LTE Modem                                                                 */
} NRF_POWER_Type;                               /*!< Size = 1560 (0x618)                                                       */



/* =========================================================================================================================== */
/* ================                                      CTRL_AP_PERI_S                                       ================ */
/* =========================================================================================================================== */


/**
  * @brief Control access port (CTRL_AP_PERI_S)
  */

typedef struct {                                /*!< CTRL_AP_PERI_S Structure                                                  */
  __IM  uint32_t  RESERVED[256];
  __IOM CTRLAPPERI_MAILBOX_Type MAILBOX;        /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED1[30];
  __IOM CTRLAPPERI_ERASEPROTECT_Type ERASEPROTECT;/*!< Unspecified                                                             */
} NRF_CTRLAPPERI_Type;                          /*!< Size = 1288 (0x508)                                                       */



/* =========================================================================================================================== */
/* ================                                         SPIM0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Peripheral Interface Master with EasyDMA 0 (SPIM0_NS)
  */

typedef struct {                                /*!< SPIM0_NS Structure                                                        */
  __IM  uint32_t  RESERVED[4];
  __OM  uint32_t  TASKS_START;                  /*!< Start SPI transaction                                                     */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop SPI transaction                                                      */
  __IM  uint32_t  RESERVED1;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend SPI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume SPI transaction                                                    */
  __IM  uint32_t  RESERVED2[27];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  SUBSCRIBE_SUSPEND;            /*!< Subscribe configuration for task SUSPEND                                  */
  __IOM uint32_t  SUBSCRIBE_RESUME;             /*!< Subscribe configuration for task RESUME                                   */
  __IM  uint32_t  RESERVED4[24];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< SPI transaction has stopped                                               */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< End of RXD buffer reached                                                 */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  EVENTS_END;                   /*!< End of RXD buffer and TXD buffer reached                                  */
  __IM  uint32_t  RESERVED7;
  __IOM uint32_t  EVENTS_ENDTX;                 /*!< End of TXD buffer reached                                                 */
  __IM  uint32_t  RESERVED8[10];
  __IOM uint32_t  EVENTS_STARTED;               /*!< Transaction started                                                       */
  __IM  uint32_t  RESERVED9[13];
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED10[2];
  __IOM uint32_t  PUBLISH_ENDRX;                /*!< Publish configuration for event ENDRX                                     */
  __IM  uint32_t  RESERVED11;
  __IOM uint32_t  PUBLISH_END;                  /*!< Publish configuration for event END                                       */
  __IM  uint32_t  RESERVED12;
  __IOM uint32_t  PUBLISH_ENDTX;                /*!< Publish configuration for event ENDTX                                     */
  __IM  uint32_t  RESERVED13[10];
  __IOM uint32_t  PUBLISH_STARTED;              /*!< Publish configuration for event STARTED                                   */
  __IM  uint32_t  RESERVED14[12];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED15[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED16[125];
  __IOM uint32_t  ENABLE;                       /*!< Enable SPIM                                                               */
  __IM  uint32_t  RESERVED17;
  __IOM SPIM_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED18[4];
  __IOM uint32_t  FREQUENCY;                    /*!< SPI frequency. Accuracy depends on the HFCLK source selected.             */
  __IM  uint32_t  RESERVED19[3];
  __IOM SPIM_RXD_Type RXD;                      /*!< RXD EasyDMA channel                                                       */
  __IOM SPIM_TXD_Type TXD;                      /*!< TXD EasyDMA channel                                                       */
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED20[26];
  __IOM uint32_t  ORC;                          /*!< Over-read character. Character clocked out in case an over-read
                                                     of the TXD buffer.                                                        */
} NRF_SPIM_Type;                                /*!< Size = 1476 (0x5c4)                                                       */



/* =========================================================================================================================== */
/* ================                                         SPIS0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief SPI Slave 0 (SPIS0_NS)
  */

typedef struct {                                /*!< SPIS0_NS Structure                                                        */
  __IM  uint32_t  RESERVED[9];
  __OM  uint32_t  TASKS_ACQUIRE;                /*!< Acquire SPI semaphore                                                     */
  __OM  uint32_t  TASKS_RELEASE;                /*!< Release SPI semaphore, enabling the SPI slave to acquire it               */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  SUBSCRIBE_ACQUIRE;            /*!< Subscribe configuration for task ACQUIRE                                  */
  __IOM uint32_t  SUBSCRIBE_RELEASE;            /*!< Subscribe configuration for task RELEASE                                  */
  __IM  uint32_t  RESERVED2[22];
  __IOM uint32_t  EVENTS_END;                   /*!< Granted transaction completed                                             */
  __IM  uint32_t  RESERVED3[2];
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< End of RXD buffer reached                                                 */
  __IM  uint32_t  RESERVED4[5];
  __IOM uint32_t  EVENTS_ACQUIRED;              /*!< Semaphore acquired                                                        */
  __IM  uint32_t  RESERVED5[22];
  __IOM uint32_t  PUBLISH_END;                  /*!< Publish configuration for event END                                       */
  __IM  uint32_t  RESERVED6[2];
  __IOM uint32_t  PUBLISH_ENDRX;                /*!< Publish configuration for event ENDRX                                     */
  __IM  uint32_t  RESERVED7[5];
  __IOM uint32_t  PUBLISH_ACQUIRED;             /*!< Publish configuration for event ACQUIRED                                  */
  __IM  uint32_t  RESERVED8[21];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED9[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED10[61];
  __IM  uint32_t  SEMSTAT;                      /*!< Semaphore status register                                                 */
  __IM  uint32_t  RESERVED11[15];
  __IOM uint32_t  STATUS;                       /*!< Status from last transaction                                              */
  __IM  uint32_t  RESERVED12[47];
  __IOM uint32_t  ENABLE;                       /*!< Enable SPI slave                                                          */
  __IM  uint32_t  RESERVED13;
  __IOM SPIS_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED14[7];
  __IOM SPIS_RXD_Type RXD;                      /*!< Unspecified                                                               */
  __IOM SPIS_TXD_Type TXD;                      /*!< Unspecified                                                               */
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED15;
  __IOM uint32_t  DEF;                          /*!< Default character. Character clocked out in case of an ignored
                                                     transaction.                                                              */
  __IM  uint32_t  RESERVED16[24];
  __IOM uint32_t  ORC;                          /*!< Over-read character                                                       */
} NRF_SPIS_Type;                                /*!< Size = 1476 (0x5c4)                                                       */



/* =========================================================================================================================== */
/* ================                                         TWIM0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief I2C compatible Two-Wire Master Interface with EasyDMA 0 (TWIM0_NS)
  */

typedef struct {                                /*!< TWIM0_NS Structure                                                        */
  __OM  uint32_t  TASKS_STARTRX;                /*!< Start TWI receive sequence                                                */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_STARTTX;                /*!< Start TWI transmit sequence                                               */
  __IM  uint32_t  RESERVED1[2];
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop TWI transaction. Must be issued while the TWI master is
                                                     not suspended.                                                            */
  __IM  uint32_t  RESERVED2;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend TWI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume TWI transaction                                                    */
  __IM  uint32_t  RESERVED3[23];
  __IOM uint32_t  SUBSCRIBE_STARTRX;            /*!< Subscribe configuration for task STARTRX                                  */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  SUBSCRIBE_STARTTX;            /*!< Subscribe configuration for task STARTTX                                  */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  SUBSCRIBE_SUSPEND;            /*!< Subscribe configuration for task SUSPEND                                  */
  __IOM uint32_t  SUBSCRIBE_RESUME;             /*!< Subscribe configuration for task RESUME                                   */
  __IM  uint32_t  RESERVED7[24];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< TWI stopped                                                               */
  __IM  uint32_t  RESERVED8[7];
  __IOM uint32_t  EVENTS_ERROR;                 /*!< TWI error                                                                 */
  __IM  uint32_t  RESERVED9[8];
  __IOM uint32_t  EVENTS_SUSPENDED;             /*!< SUSPEND task has been issued, TWI traffic is now suspended.               */
  __IOM uint32_t  EVENTS_RXSTARTED;             /*!< Receive sequence started                                                  */
  __IOM uint32_t  EVENTS_TXSTARTED;             /*!< Transmit sequence started                                                 */
  __IM  uint32_t  RESERVED10[2];
  __IOM uint32_t  EVENTS_LASTRX;                /*!< Byte boundary, starting to receive the last byte                          */
  __IOM uint32_t  EVENTS_LASTTX;                /*!< Byte boundary, starting to transmit the last byte                         */
  __IM  uint32_t  RESERVED11[8];
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED12[7];
  __IOM uint32_t  PUBLISH_ERROR;                /*!< Publish configuration for event ERROR                                     */
  __IM  uint32_t  RESERVED13[8];
  __IOM uint32_t  PUBLISH_SUSPENDED;            /*!< Publish configuration for event SUSPENDED                                 */
  __IOM uint32_t  PUBLISH_RXSTARTED;            /*!< Publish configuration for event RXSTARTED                                 */
  __IOM uint32_t  PUBLISH_TXSTARTED;            /*!< Publish configuration for event TXSTARTED                                 */
  __IM  uint32_t  RESERVED14[2];
  __IOM uint32_t  PUBLISH_LASTRX;               /*!< Publish configuration for event LASTRX                                    */
  __IOM uint32_t  PUBLISH_LASTTX;               /*!< Publish configuration for event LASTTX                                    */
  __IM  uint32_t  RESERVED15[7];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED16[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED17[110];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source                                                              */
  __IM  uint32_t  RESERVED18[14];
  __IOM uint32_t  ENABLE;                       /*!< Enable TWIM                                                               */
  __IM  uint32_t  RESERVED19;
  __IOM TWIM_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED20[5];
  __IOM uint32_t  FREQUENCY;                    /*!< TWI frequency. Accuracy depends on the HFCLK source selected.             */
  __IM  uint32_t  RESERVED21[3];
  __IOM TWIM_RXD_Type RXD;                      /*!< RXD EasyDMA channel                                                       */
  __IOM TWIM_TXD_Type TXD;                      /*!< TXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED22[13];
  __IOM uint32_t  ADDRESS;                      /*!< Address used in the TWI transfer                                          */
} NRF_TWIM_Type;                                /*!< Size = 1420 (0x58c)                                                       */



/* =========================================================================================================================== */
/* ================                                         TWIS0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief I2C compatible Two-Wire Slave Interface with EasyDMA 0 (TWIS0_NS)
  */

typedef struct {                                /*!< TWIS0_NS Structure                                                        */
  __IM  uint32_t  RESERVED[5];
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop TWI transaction                                                      */
  __IM  uint32_t  RESERVED1;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend TWI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume TWI transaction                                                    */
  __IM  uint32_t  RESERVED2[3];
  __OM  uint32_t  TASKS_PREPARERX;              /*!< Prepare the TWI slave to respond to a write command                       */
  __OM  uint32_t  TASKS_PREPARETX;              /*!< Prepare the TWI slave to respond to a read command                        */
  __IM  uint32_t  RESERVED3[23];
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  SUBSCRIBE_SUSPEND;            /*!< Subscribe configuration for task SUSPEND                                  */
  __IOM uint32_t  SUBSCRIBE_RESUME;             /*!< Subscribe configuration for task RESUME                                   */
  __IM  uint32_t  RESERVED5[3];
  __IOM uint32_t  SUBSCRIBE_PREPARERX;          /*!< Subscribe configuration for task PREPARERX                                */
  __IOM uint32_t  SUBSCRIBE_PREPARETX;          /*!< Subscribe configuration for task PREPARETX                                */
  __IM  uint32_t  RESERVED6[19];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< TWI stopped                                                               */
  __IM  uint32_t  RESERVED7[7];
  __IOM uint32_t  EVENTS_ERROR;                 /*!< TWI error                                                                 */
  __IM  uint32_t  RESERVED8[9];
  __IOM uint32_t  EVENTS_RXSTARTED;             /*!< Receive sequence started                                                  */
  __IOM uint32_t  EVENTS_TXSTARTED;             /*!< Transmit sequence started                                                 */
  __IM  uint32_t  RESERVED9[4];
  __IOM uint32_t  EVENTS_WRITE;                 /*!< Write command received                                                    */
  __IOM uint32_t  EVENTS_READ;                  /*!< Read command received                                                     */
  __IM  uint32_t  RESERVED10[6];
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED11[7];
  __IOM uint32_t  PUBLISH_ERROR;                /*!< Publish configuration for event ERROR                                     */
  __IM  uint32_t  RESERVED12[9];
  __IOM uint32_t  PUBLISH_RXSTARTED;            /*!< Publish configuration for event RXSTARTED                                 */
  __IOM uint32_t  PUBLISH_TXSTARTED;            /*!< Publish configuration for event TXSTARTED                                 */
  __IM  uint32_t  RESERVED13[4];
  __IOM uint32_t  PUBLISH_WRITE;                /*!< Publish configuration for event WRITE                                     */
  __IOM uint32_t  PUBLISH_READ;                 /*!< Publish configuration for event READ                                      */
  __IM  uint32_t  RESERVED14[5];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED15[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED16[113];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source                                                              */
  __IM  uint32_t  MATCH;                        /*!< Status register indicating which address had a match                      */
  __IM  uint32_t  RESERVED17[10];
  __IOM uint32_t  ENABLE;                       /*!< Enable TWIS                                                               */
  __IM  uint32_t  RESERVED18;
  __IOM TWIS_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED19[9];
  __IOM TWIS_RXD_Type RXD;                      /*!< RXD EasyDMA channel                                                       */
  __IOM TWIS_TXD_Type TXD;                      /*!< TXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED20[13];
  __IOM uint32_t  ADDRESS[2];                   /*!< Description collection: TWI slave address n                               */
  __IM  uint32_t  RESERVED21;
  __IOM uint32_t  CONFIG;                       /*!< Configuration register for the address match mechanism                    */
  __IM  uint32_t  RESERVED22[10];
  __IOM uint32_t  ORC;                          /*!< Over-read character. Character sent out in case of an over-read
                                                     of the transmit buffer.                                                   */
} NRF_TWIS_Type;                                /*!< Size = 1476 (0x5c4)                                                       */



/* =========================================================================================================================== */
/* ================                                         UARTE0_NS                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief UART with EasyDMA 0 (UARTE0_NS)
  */

typedef struct {                                /*!< UARTE0_NS Structure                                                       */
  __OM  uint32_t  TASKS_STARTRX;                /*!< Start UART receiver                                                       */
  __OM  uint32_t  TASKS_STOPRX;                 /*!< Stop UART receiver                                                        */
  __OM  uint32_t  TASKS_STARTTX;                /*!< Start UART transmitter                                                    */
  __OM  uint32_t  TASKS_STOPTX;                 /*!< Stop UART transmitter                                                     */
  __IM  uint32_t  RESERVED[7];
  __OM  uint32_t  TASKS_FLUSHRX;                /*!< Flush RX FIFO into RX buffer                                              */
  __IM  uint32_t  RESERVED1[20];
  __IOM uint32_t  SUBSCRIBE_STARTRX;            /*!< Subscribe configuration for task STARTRX                                  */
  __IOM uint32_t  SUBSCRIBE_STOPRX;             /*!< Subscribe configuration for task STOPRX                                   */
  __IOM uint32_t  SUBSCRIBE_STARTTX;            /*!< Subscribe configuration for task STARTTX                                  */
  __IOM uint32_t  SUBSCRIBE_STOPTX;             /*!< Subscribe configuration for task STOPTX                                   */
  __IM  uint32_t  RESERVED2[7];
  __IOM uint32_t  SUBSCRIBE_FLUSHRX;            /*!< Subscribe configuration for task FLUSHRX                                  */
  __IM  uint32_t  RESERVED3[20];
  __IOM uint32_t  EVENTS_CTS;                   /*!< CTS is activated (set low). Clear To Send.                                */
  __IOM uint32_t  EVENTS_NCTS;                  /*!< CTS is deactivated (set high). Not Clear To Send.                         */
  __IOM uint32_t  EVENTS_RXDRDY;                /*!< Data received in RXD (but potentially not yet transferred to
                                                     Data RAM)                                                                 */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< Receive buffer is filled up                                               */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  EVENTS_TXDRDY;                /*!< Data sent from TXD                                                        */
  __IOM uint32_t  EVENTS_ENDTX;                 /*!< Last TX byte transmitted                                                  */
  __IOM uint32_t  EVENTS_ERROR;                 /*!< Error detected                                                            */
  __IM  uint32_t  RESERVED6[7];
  __IOM uint32_t  EVENTS_RXTO;                  /*!< Receiver timeout                                                          */
  __IM  uint32_t  RESERVED7;
  __IOM uint32_t  EVENTS_RXSTARTED;             /*!< UART receiver has started                                                 */
  __IOM uint32_t  EVENTS_TXSTARTED;             /*!< UART transmitter has started                                              */
  __IM  uint32_t  RESERVED8;
  __IOM uint32_t  EVENTS_TXSTOPPED;             /*!< Transmitter stopped                                                       */
  __IM  uint32_t  RESERVED9[9];
  __IOM uint32_t  PUBLISH_CTS;                  /*!< Publish configuration for event CTS                                       */
  __IOM uint32_t  PUBLISH_NCTS;                 /*!< Publish configuration for event NCTS                                      */
  __IOM uint32_t  PUBLISH_RXDRDY;               /*!< Publish configuration for event RXDRDY                                    */
  __IM  uint32_t  RESERVED10;
  __IOM uint32_t  PUBLISH_ENDRX;                /*!< Publish configuration for event ENDRX                                     */
  __IM  uint32_t  RESERVED11[2];
  __IOM uint32_t  PUBLISH_TXDRDY;               /*!< Publish configuration for event TXDRDY                                    */
  __IOM uint32_t  PUBLISH_ENDTX;                /*!< Publish configuration for event ENDTX                                     */
  __IOM uint32_t  PUBLISH_ERROR;                /*!< Publish configuration for event ERROR                                     */
  __IM  uint32_t  RESERVED12[7];
  __IOM uint32_t  PUBLISH_RXTO;                 /*!< Publish configuration for event RXTO                                      */
  __IM  uint32_t  RESERVED13;
  __IOM uint32_t  PUBLISH_RXSTARTED;            /*!< Publish configuration for event RXSTARTED                                 */
  __IOM uint32_t  PUBLISH_TXSTARTED;            /*!< Publish configuration for event TXSTARTED                                 */
  __IM  uint32_t  RESERVED14;
  __IOM uint32_t  PUBLISH_TXSTOPPED;            /*!< Publish configuration for event TXSTOPPED                                 */
  __IM  uint32_t  RESERVED15[9];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED16[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED17[93];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source This register is read/write one to clear.                    */
  __IM  uint32_t  RESERVED18[31];
  __IOM uint32_t  ENABLE;                       /*!< Enable UART                                                               */
  __IM  uint32_t  RESERVED19;
  __IOM UARTE_PSEL_Type PSEL;                   /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED20[3];
  __IOM uint32_t  BAUDRATE;                     /*!< Baud rate. Accuracy depends on the HFCLK source selected.                 */
  __IM  uint32_t  RESERVED21[3];
  __IOM UARTE_RXD_Type RXD;                     /*!< RXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED22;
  __IOM UARTE_TXD_Type TXD;                     /*!< TXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED23[7];
  __IOM uint32_t  CONFIG;                       /*!< Configuration of parity and hardware flow control                         */
} NRF_UARTE_Type;                               /*!< Size = 1392 (0x570)                                                       */



/* =========================================================================================================================== */
/* ================                                         GPIOTE0_S                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief GPIO Tasks and Events 0 (GPIOTE0_S)
  */

typedef struct {                                /*!< GPIOTE0_S Structure                                                       */
  __OM  uint32_t  TASKS_OUT[8];                 /*!< Description collection: Task for writing to pin specified in
                                                     CONFIG[n].PSEL. Action on pin is configured in CONFIG[n].POLARITY.        */
  __IM  uint32_t  RESERVED[4];
  __OM  uint32_t  TASKS_SET[8];                 /*!< Description collection: Task for writing to pin specified in
                                                     CONFIG[n].PSEL. Action on pin is to set it high.                          */
  __IM  uint32_t  RESERVED1[4];
  __OM  uint32_t  TASKS_CLR[8];                 /*!< Description collection: Task for writing to pin specified in
                                                     CONFIG[n].PSEL. Action on pin is to set it low.                           */
  __IOM uint32_t  SUBSCRIBE_OUT[8];             /*!< Description collection: Subscribe configuration for task OUT[n]           */
  __IM  uint32_t  RESERVED2[4];
  __IOM uint32_t  SUBSCRIBE_SET[8];             /*!< Description collection: Subscribe configuration for task SET[n]           */
  __IM  uint32_t  RESERVED3[4];
  __IOM uint32_t  SUBSCRIBE_CLR[8];             /*!< Description collection: Subscribe configuration for task CLR[n]           */
  __IOM uint32_t  EVENTS_IN[8];                 /*!< Description collection: Event generated from pin specified in
                                                     CONFIG[n].PSEL                                                            */
  __IM  uint32_t  RESERVED4[23];
  __IOM uint32_t  EVENTS_PORT;                  /*!< Event generated from multiple input GPIO pins with SENSE mechanism
                                                     enabled                                                                   */
  __IOM uint32_t  PUBLISH_IN[8];                /*!< Description collection: Publish configuration for event IN[n]             */
  __IM  uint32_t  RESERVED5[23];
  __IOM uint32_t  PUBLISH_PORT;                 /*!< Publish configuration for event PORT                                      */
  __IM  uint32_t  RESERVED6[65];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED7[129];
  __IOM uint32_t  CONFIG[8];                    /*!< Description collection: Configuration for OUT[n], SET[n], and
                                                     CLR[n] tasks and IN[n] event                                              */
} NRF_GPIOTE_Type;                              /*!< Size = 1328 (0x530)                                                       */



/* =========================================================================================================================== */
/* ================                                         SAADC_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Analog to Digital Converter 0 (SAADC_NS)
  */

typedef struct {                                /*!< SAADC_NS Structure                                                        */
  __OM  uint32_t  TASKS_START;                  /*!< Start the ADC and prepare the result buffer in RAM                        */
  __OM  uint32_t  TASKS_SAMPLE;                 /*!< Take one ADC sample, if scan is enabled all channels are sampled          */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop the ADC and terminate any on-going conversion                        */
  __OM  uint32_t  TASKS_CALIBRATEOFFSET;        /*!< Starts offset auto-calibration                                            */
  __IM  uint32_t  RESERVED[28];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_SAMPLE;             /*!< Subscribe configuration for task SAMPLE                                   */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_CALIBRATEOFFSET;    /*!< Subscribe configuration for task CALIBRATEOFFSET                          */
  __IM  uint32_t  RESERVED1[28];
  __IOM uint32_t  EVENTS_STARTED;               /*!< The ADC has started                                                       */
  __IOM uint32_t  EVENTS_END;                   /*!< The ADC has filled up the Result buffer                                   */
  __IOM uint32_t  EVENTS_DONE;                  /*!< A conversion task has been completed. Depending on the mode,
                                                     multiple conversions might be needed for a result to be
                                                     transferred to RAM.                                                       */
  __IOM uint32_t  EVENTS_RESULTDONE;            /*!< A result is ready to get transferred to RAM.                              */
  __IOM uint32_t  EVENTS_CALIBRATEDONE;         /*!< Calibration is complete                                                   */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< The ADC has stopped                                                       */
  __IOM SAADC_EVENTS_CH_Type EVENTS_CH[8];      /*!< Peripheral events.                                                        */
  __IM  uint32_t  RESERVED2[10];
  __IOM uint32_t  PUBLISH_STARTED;              /*!< Publish configuration for event STARTED                                   */
  __IOM uint32_t  PUBLISH_END;                  /*!< Publish configuration for event END                                       */
  __IOM uint32_t  PUBLISH_DONE;                 /*!< Publish configuration for event DONE                                      */
  __IOM uint32_t  PUBLISH_RESULTDONE;           /*!< Publish configuration for event RESULTDONE                                */
  __IOM uint32_t  PUBLISH_CALIBRATEDONE;        /*!< Publish configuration for event CALIBRATEDONE                             */
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IOM SAADC_PUBLISH_CH_Type PUBLISH_CH[8];    /*!< Publish configuration for events                                          */
  __IM  uint32_t  RESERVED3[74];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[61];
  __IM  uint32_t  STATUS;                       /*!< Status                                                                    */
  __IM  uint32_t  RESERVED5[63];
  __IOM uint32_t  ENABLE;                       /*!< Enable or disable ADC                                                     */
  __IM  uint32_t  RESERVED6[3];
  __IOM SAADC_CH_Type CH[8];                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED7[24];
  __IOM uint32_t  RESOLUTION;                   /*!< Resolution configuration                                                  */
  __IOM uint32_t  OVERSAMPLE;                   /*!< Oversampling configuration. OVERSAMPLE should not be combined
                                                     with SCAN. The RESOLUTION is applied before averaging,
                                                     thus for high OVERSAMPLE a higher RESOLUTION should be
                                                     used.                                                                     */
  __IOM uint32_t  SAMPLERATE;                   /*!< Controls normal or continuous sample rate                                 */
  __IM  uint32_t  RESERVED8[12];
  __IOM SAADC_RESULT_Type RESULT;               /*!< RESULT EasyDMA channel                                                    */
} NRF_SAADC_Type;                               /*!< Size = 1592 (0x638)                                                       */



/* =========================================================================================================================== */
/* ================                                         TIMER0_NS                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief Timer/Counter 0 (TIMER0_NS)
  */

typedef struct {                                /*!< TIMER0_NS Structure                                                       */
  __OM  uint32_t  TASKS_START;                  /*!< Start Timer                                                               */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop Timer                                                                */
  __OM  uint32_t  TASKS_COUNT;                  /*!< Increment Timer (Counter mode only)                                       */
  __OM  uint32_t  TASKS_CLEAR;                  /*!< Clear time                                                                */
  __OM  uint32_t  TASKS_SHUTDOWN;               /*!< Deprecated register - Shut down timer                                     */
  __IM  uint32_t  RESERVED[11];
  __OM  uint32_t  TASKS_CAPTURE[6];             /*!< Description collection: Capture Timer value to CC[n] register             */
  __IM  uint32_t  RESERVED1[10];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_COUNT;              /*!< Subscribe configuration for task COUNT                                    */
  __IOM uint32_t  SUBSCRIBE_CLEAR;              /*!< Subscribe configuration for task CLEAR                                    */
  __IOM uint32_t  SUBSCRIBE_SHUTDOWN;           /*!< Deprecated register - Subscribe configuration for task SHUTDOWN           */
  __IM  uint32_t  RESERVED2[11];
  __IOM uint32_t  SUBSCRIBE_CAPTURE[6];         /*!< Description collection: Subscribe configuration for task CAPTURE[n]       */
  __IM  uint32_t  RESERVED3[26];
  __IOM uint32_t  EVENTS_COMPARE[6];            /*!< Description collection: Compare event on CC[n] match                      */
  __IM  uint32_t  RESERVED4[26];
  __IOM uint32_t  PUBLISH_COMPARE[6];           /*!< Description collection: Publish configuration for event COMPARE[n]        */
  __IM  uint32_t  RESERVED5[10];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED6[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED7[126];
  __IOM uint32_t  MODE;                         /*!< Timer mode selection                                                      */
  __IOM uint32_t  BITMODE;                      /*!< Configure the number of bits used by the TIMER                            */
  __IM  uint32_t  RESERVED8;
  __IOM uint32_t  PRESCALER;                    /*!< Timer prescaler register                                                  */
  __IOM uint32_t  ONESHOTEN[6];                 /*!< Description collection: Enable one-shot operation for Capture/Compare
                                                     channel n                                                                 */
  __IM  uint32_t  RESERVED9[5];
  __IOM uint32_t  CC[6];                        /*!< Description collection: Capture/Compare register n                        */
} NRF_TIMER_Type;                               /*!< Size = 1368 (0x558)                                                       */



/* =========================================================================================================================== */
/* ================                                          RTC0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Real-time counter 0 (RTC0_NS)
  */

typedef struct {                                /*!< RTC0_NS Structure                                                         */
  __OM  uint32_t  TASKS_START;                  /*!< Start RTC counter                                                         */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop RTC counter                                                          */
  __OM  uint32_t  TASKS_CLEAR;                  /*!< Clear RTC counter                                                         */
  __OM  uint32_t  TASKS_TRIGOVRFLW;             /*!< Set counter to 0xFFFFF0                                                   */
  __IM  uint32_t  RESERVED[28];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_CLEAR;              /*!< Subscribe configuration for task CLEAR                                    */
  __IOM uint32_t  SUBSCRIBE_TRIGOVRFLW;         /*!< Subscribe configuration for task TRIGOVRFLW                               */
  __IM  uint32_t  RESERVED1[28];
  __IOM uint32_t  EVENTS_TICK;                  /*!< Event on counter increment                                                */
  __IOM uint32_t  EVENTS_OVRFLW;                /*!< Event on counter overflow                                                 */
  __IM  uint32_t  RESERVED2[14];
  __IOM uint32_t  EVENTS_COMPARE[4];            /*!< Description collection: Compare event on CC[n] match                      */
  __IM  uint32_t  RESERVED3[12];
  __IOM uint32_t  PUBLISH_TICK;                 /*!< Publish configuration for event TICK                                      */
  __IOM uint32_t  PUBLISH_OVRFLW;               /*!< Publish configuration for event OVRFLW                                    */
  __IM  uint32_t  RESERVED4[14];
  __IOM uint32_t  PUBLISH_COMPARE[4];           /*!< Description collection: Publish configuration for event COMPARE[n]        */
  __IM  uint32_t  RESERVED5[77];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED6[13];
  __IOM uint32_t  EVTEN;                        /*!< Enable or disable event routing                                           */
  __IOM uint32_t  EVTENSET;                     /*!< Enable event routing                                                      */
  __IOM uint32_t  EVTENCLR;                     /*!< Disable event routing                                                     */
  __IM  uint32_t  RESERVED7[110];
  __IM  uint32_t  COUNTER;                      /*!< Current counter value                                                     */
  __IOM uint32_t  PRESCALER;                    /*!< 12-bit prescaler for counter frequency (32768/(PRESCALER+1)).
                                                     Must be written when RTC is stopped.                                      */
  __IM  uint32_t  RESERVED8[13];
  __IOM uint32_t  CC[4];                        /*!< Description collection: Compare register n                                */
} NRF_RTC_Type;                                 /*!< Size = 1360 (0x550)                                                       */



/* =========================================================================================================================== */
/* ================                                         DPPIC_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Distributed programmable peripheral interconnect controller 0 (DPPIC_NS)
  */

typedef struct {                                /*!< DPPIC_NS Structure                                                        */
  __OM  DPPIC_TASKS_CHG_Type TASKS_CHG[6];      /*!< Channel group tasks                                                       */
  __IM  uint32_t  RESERVED[20];
  __IOM DPPIC_SUBSCRIBE_CHG_Type SUBSCRIBE_CHG[6];/*!< Subscribe configuration for tasks                                       */
  __IM  uint32_t  RESERVED1[276];
  __IOM uint32_t  CHEN;                         /*!< Channel enable register                                                   */
  __IOM uint32_t  CHENSET;                      /*!< Channel enable set register                                               */
  __IOM uint32_t  CHENCLR;                      /*!< Channel enable clear register                                             */
  __IM  uint32_t  RESERVED2[189];
  __IOM uint32_t  CHG[6];                       /*!< Description collection: Channel group n Note: Writes to this
                                                     register are ignored if either SUBSCRIBE_CHG[n].EN or SUBSCRIBE_CHG[n].DI
                                                     is enabled                                                                */
} NRF_DPPIC_Type;                               /*!< Size = 2072 (0x818)                                                       */



/* =========================================================================================================================== */
/* ================                                          WDT_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Watchdog Timer 0 (WDT_NS)
  */

typedef struct {                                /*!< WDT_NS Structure                                                          */
  __OM  uint32_t  TASKS_START;                  /*!< Start the watchdog                                                        */
  __IM  uint32_t  RESERVED[31];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IM  uint32_t  RESERVED1[31];
  __IOM uint32_t  EVENTS_TIMEOUT;               /*!< Watchdog timeout                                                          */
  __IM  uint32_t  RESERVED2[31];
  __IOM uint32_t  PUBLISH_TIMEOUT;              /*!< Publish configuration for event TIMEOUT                                   */
  __IM  uint32_t  RESERVED3[96];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[61];
  __IM  uint32_t  RUNSTATUS;                    /*!< Run status                                                                */
  __IM  uint32_t  REQSTATUS;                    /*!< Request status                                                            */
  __IM  uint32_t  RESERVED5[63];
  __IOM uint32_t  CRV;                          /*!< Counter reload value                                                      */
  __IOM uint32_t  RREN;                         /*!< Enable register for reload request registers                              */
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED6[60];
  __OM  uint32_t  RR[8];                        /*!< Description collection: Reload request n                                  */
} NRF_WDT_Type;                                 /*!< Size = 1568 (0x620)                                                       */



/* =========================================================================================================================== */
/* ================                                          EGU0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Event generator unit 0 (EGU0_NS)
  */

typedef struct {                                /*!< EGU0_NS Structure                                                         */
  __OM  uint32_t  TASKS_TRIGGER[16];            /*!< Description collection: Trigger n for triggering the corresponding
                                                     TRIGGERED[n] event                                                        */
  __IM  uint32_t  RESERVED[16];
  __IOM uint32_t  SUBSCRIBE_TRIGGER[16];        /*!< Description collection: Subscribe configuration for task TRIGGER[n]       */
  __IM  uint32_t  RESERVED1[16];
  __IOM uint32_t  EVENTS_TRIGGERED[16];         /*!< Description collection: Event number n generated by triggering
                                                     the corresponding TRIGGER[n] task                                         */
  __IM  uint32_t  RESERVED2[16];
  __IOM uint32_t  PUBLISH_TRIGGERED[16];        /*!< Description collection: Publish configuration for event TRIGGERED[n]      */
  __IM  uint32_t  RESERVED3[80];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
} NRF_EGU_Type;                                 /*!< Size = 780 (0x30c)                                                        */



/* =========================================================================================================================== */
/* ================                                          PWM0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Pulse width modulation unit 0 (PWM0_NS)
  */

typedef struct {                                /*!< PWM0_NS Structure                                                         */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_STOP;                   /*!< Stops PWM pulse generation on all channels at the end of current
                                                     PWM period, and stops sequence playback                                   */
  __OM  uint32_t  TASKS_SEQSTART[2];            /*!< Description collection: Loads the first PWM value on all enabled
                                                     channels from sequence n, and starts playing that sequence
                                                     at the rate defined in SEQ[n]REFRESH and/or DECODER.MODE.
                                                     Causes PWM generation to start if not running.                            */
  __OM  uint32_t  TASKS_NEXTSTEP;               /*!< Steps by one value in the current sequence on all enabled channels
                                                     if DECODER.MODE=NextStep. Does not cause PWM generation
                                                     to start if not running.                                                  */
  __IM  uint32_t  RESERVED1[28];
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_SEQSTART[2];        /*!< Description collection: Subscribe configuration for task SEQSTART[n]      */
  __IOM uint32_t  SUBSCRIBE_NEXTSTEP;           /*!< Subscribe configuration for task NEXTSTEP                                 */
  __IM  uint32_t  RESERVED2[28];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< Response to STOP task, emitted when PWM pulses are no longer
                                                     generated                                                                 */
  __IOM uint32_t  EVENTS_SEQSTARTED[2];         /*!< Description collection: First PWM period started on sequence
                                                     n                                                                         */
  __IOM uint32_t  EVENTS_SEQEND[2];             /*!< Description collection: Emitted at end of every sequence n,
                                                     when last value from RAM has been applied to wave counter                 */
  __IOM uint32_t  EVENTS_PWMPERIODEND;          /*!< Emitted at the end of each PWM period                                     */
  __IOM uint32_t  EVENTS_LOOPSDONE;             /*!< Concatenated sequences have been played the amount of times
                                                     defined in LOOP.CNT                                                       */
  __IM  uint32_t  RESERVED3[25];
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IOM uint32_t  PUBLISH_SEQSTARTED[2];        /*!< Description collection: Publish configuration for event SEQSTARTED[n]     */
  __IOM uint32_t  PUBLISH_SEQEND[2];            /*!< Description collection: Publish configuration for event SEQEND[n]         */
  __IOM uint32_t  PUBLISH_PWMPERIODEND;         /*!< Publish configuration for event PWMPERIODEND                              */
  __IOM uint32_t  PUBLISH_LOOPSDONE;            /*!< Publish configuration for event LOOPSDONE                                 */
  __IM  uint32_t  RESERVED4[24];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED5[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED6[125];
  __IOM uint32_t  ENABLE;                       /*!< PWM module enable register                                                */
  __IOM uint32_t  MODE;                         /*!< Selects operating mode of the wave counter                                */
  __IOM uint32_t  COUNTERTOP;                   /*!< Value up to which the pulse generator counter counts                      */
  __IOM uint32_t  PRESCALER;                    /*!< Configuration for PWM_CLK                                                 */
  __IOM uint32_t  DECODER;                      /*!< Configuration of the decoder                                              */
  __IOM uint32_t  LOOP;                         /*!< Number of playbacks of a loop                                             */
  __IM  uint32_t  RESERVED7[2];
  __IOM PWM_SEQ_Type SEQ[2];                    /*!< Unspecified                                                               */
  __IOM PWM_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
} NRF_PWM_Type;                                 /*!< Size = 1392 (0x570)                                                       */



/* =========================================================================================================================== */
/* ================                                          PDM_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Pulse Density Modulation (Digital Microphone) Interface 0 (PDM_NS)
  */

typedef struct {                                /*!< PDM_NS Structure                                                          */
  __OM  uint32_t  TASKS_START;                  /*!< Starts continuous PDM transfer                                            */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stops PDM transfer                                                        */
  __IM  uint32_t  RESERVED[30];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  EVENTS_STARTED;               /*!< PDM transfer has started                                                  */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< PDM transfer has finished                                                 */
  __IOM uint32_t  EVENTS_END;                   /*!< The PDM has written the last sample specified by SAMPLE.MAXCNT
                                                     (or the last sample after a STOP task has been received)
                                                     to Data RAM                                                               */
  __IM  uint32_t  RESERVED2[29];
  __IOM uint32_t  PUBLISH_STARTED;              /*!< Publish configuration for event STARTED                                   */
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IOM uint32_t  PUBLISH_END;                  /*!< Publish configuration for event END                                       */
  __IM  uint32_t  RESERVED3[93];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[125];
  __IOM uint32_t  ENABLE;                       /*!< PDM module enable register                                                */
  __IOM uint32_t  PDMCLKCTRL;                   /*!< PDM clock generator control                                               */
  __IOM uint32_t  MODE;                         /*!< Defines the routing of the connected PDM microphones' signals             */
  __IM  uint32_t  RESERVED5[3];
  __IOM uint32_t  GAINL;                        /*!< Left output gain adjustment                                               */
  __IOM uint32_t  GAINR;                        /*!< Right output gain adjustment                                              */
  __IOM uint32_t  RATIO;                        /*!< Selects the ratio between PDM_CLK and output sample rate. Change
                                                     PDMCLKCTRL accordingly.                                                   */
  __IM  uint32_t  RESERVED6[7];
  __IOM PDM_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED7[6];
  __IOM PDM_SAMPLE_Type SAMPLE;                 /*!< Unspecified                                                               */
} NRF_PDM_Type;                                 /*!< Size = 1384 (0x568)                                                       */



/* =========================================================================================================================== */
/* ================                                          I2S_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Inter-IC Sound 0 (I2S_NS)
  */

typedef struct {                                /*!< I2S_NS Structure                                                          */
  __OM  uint32_t  TASKS_START;                  /*!< Starts continuous I2S transfer. Also starts MCK generator when
                                                     this is enabled.                                                          */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stops I2S transfer. Also stops MCK generator. Triggering this
                                                     task will cause the STOPPED event to be generated.                        */
  __IM  uint32_t  RESERVED[30];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED1[31];
  __IOM uint32_t  EVENTS_RXPTRUPD;              /*!< The RXD.PTR register has been copied to internal double-buffers.
                                                     When the I2S module is started and RX is enabled, this
                                                     event will be generated for every RXTXD.MAXCNT words that
                                                     are received on the SDIN pin.                                             */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< I2S transfer stopped.                                                     */
  __IM  uint32_t  RESERVED2[2];
  __IOM uint32_t  EVENTS_TXPTRUPD;              /*!< The TDX.PTR register has been copied to internal double-buffers.
                                                     When the I2S module is started and TX is enabled, this
                                                     event will be generated for every RXTXD.MAXCNT words that
                                                     are sent on the SDOUT pin.                                                */
  __IM  uint32_t  RESERVED3[27];
  __IOM uint32_t  PUBLISH_RXPTRUPD;             /*!< Publish configuration for event RXPTRUPD                                  */
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED4[2];
  __IOM uint32_t  PUBLISH_TXPTRUPD;             /*!< Publish configuration for event TXPTRUPD                                  */
  __IM  uint32_t  RESERVED5[90];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED6[125];
  __IOM uint32_t  ENABLE;                       /*!< Enable I2S module.                                                        */
  __IOM I2S_CONFIG_Type CONFIG;                 /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED7[3];
  __IOM I2S_RXD_Type RXD;                       /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED8;
  __IOM I2S_TXD_Type TXD;                       /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED9[3];
  __IOM I2S_RXTXD_Type RXTXD;                   /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED10[3];
  __IOM I2S_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
} NRF_I2S_Type;                                 /*!< Size = 1396 (0x574)                                                       */



/* =========================================================================================================================== */
/* ================                                          IPC_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Interprocessor communication 0 (IPC_NS)
  */

typedef struct {                                /*!< IPC_NS Structure                                                          */
  __OM  uint32_t  TASKS_SEND[8];                /*!< Description collection: Trigger events on IPC channel enabled
                                                     in SEND_CNF[n]                                                            */
  __IM  uint32_t  RESERVED[24];
  __IOM uint32_t  SUBSCRIBE_SEND[8];            /*!< Description collection: Subscribe configuration for task SEND[n]          */
  __IM  uint32_t  RESERVED1[24];
  __IOM uint32_t  EVENTS_RECEIVE[8];            /*!< Description collection: Event received on one or more of the
                                                     enabled IPC channels in RECEIVE_CNF[n]                                    */
  __IM  uint32_t  RESERVED2[24];
  __IOM uint32_t  PUBLISH_RECEIVE[8];           /*!< Description collection: Publish configuration for event RECEIVE[n]        */
  __IM  uint32_t  RESERVED3[88];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  INTPEND;                      /*!< Pending interrupts                                                        */
  __IM  uint32_t  RESERVED4[128];
  __IOM uint32_t  SEND_CNF[8];                  /*!< Description collection: Send event configuration for TASKS_SEND[n]        */
  __IM  uint32_t  RESERVED5[24];
  __IOM uint32_t  RECEIVE_CNF[8];               /*!< Description collection: Receive event configuration for EVENTS_RECEIVE[n] */
  __IM  uint32_t  RESERVED6[24];
  __IOM uint32_t  GPMEM[4];                     /*!< Description collection: General purpose memory                            */
} NRF_IPC_Type;                                 /*!< Size = 1568 (0x620)                                                       */



/* =========================================================================================================================== */
/* ================                                          FPU_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief FPU 0 (FPU_NS)
  */

typedef struct {                                /*!< FPU_NS Structure                                                          */
  __IM  uint32_t  UNUSED;                       /*!< Unused.                                                                   */
} NRF_FPU_Type;                                 /*!< Size = 4 (0x4)                                                            */



/* =========================================================================================================================== */
/* ================                                          KMU_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Key management unit 0 (KMU_NS)
  */

typedef struct {                                /*!< KMU_NS Structure                                                          */
  __OM  uint32_t  TASKS_PUSH_KEYSLOT;           /*!< Push a key slot over secure APB                                           */
  __IM  uint32_t  RESERVED[63];
  __IOM uint32_t  EVENTS_KEYSLOT_PUSHED;        /*!< Key slot successfully pushed over secure APB                              */
  __IOM uint32_t  EVENTS_KEYSLOT_REVOKED;       /*!< Key slot has been revoked and cannot be tasked for selection              */
  __IOM uint32_t  EVENTS_KEYSLOT_ERROR;         /*!< No key slot selected, no destination address defined, or error
                                                     during push operation                                                     */
  __IM  uint32_t  RESERVED1[125];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  INTPEND;                      /*!< Pending interrupts                                                        */
  __IM  uint32_t  RESERVED2[63];
  __IM  uint32_t  STATUS;                       /*!< Status bits for KMU operation                                             */
  __IM  uint32_t  RESERVED3[60];
  __IOM uint32_t  SELECTKEYSLOT;                /*!< Select key slot to be read over AHB or pushed over secure APB
                                                     when TASKS_PUSH_KEYSLOT is started                                        */
} NRF_KMU_Type;                                 /*!< Size = 1284 (0x504)                                                       */



/* =========================================================================================================================== */
/* ================                                          NVMC_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Non-volatile memory controller 0 (NVMC_NS)
  */

typedef struct {                                /*!< NVMC_NS Structure                                                         */
  __IM  uint32_t  RESERVED[256];
  __IM  uint32_t  READY;                        /*!< Ready flag                                                                */
  __IM  uint32_t  RESERVED1;
  __IM  uint32_t  READYNEXT;                    /*!< Ready flag                                                                */
  __IM  uint32_t  RESERVED2[62];
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED3;
  __OM  uint32_t  ERASEALL;                     /*!< Register for erasing all non-volatile user memory                         */
  __IM  uint32_t  RESERVED4[3];
  __IOM uint32_t  ERASEPAGEPARTIALCFG;          /*!< Register for partial erase configuration                                  */
  __IM  uint32_t  RESERVED5[8];
  __IOM uint32_t  ICACHECNF;                    /*!< I-code cache configuration register                                       */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  IHIT;                         /*!< I-code cache hit counter                                                  */
  __IOM uint32_t  IMISS;                        /*!< I-code cache miss counter                                                 */
  __IM  uint32_t  RESERVED7[13];
  __IOM uint32_t  CONFIGNS;                     /*!< Unspecified                                                               */
  __OM  uint32_t  WRITEUICRNS;                  /*!< Non-secure APPROTECT enable register                                      */
} NRF_NVMC_Type;                                /*!< Size = 1420 (0x58c)                                                       */



/* =========================================================================================================================== */
/* ================                                          VMC_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Volatile Memory controller 0 (VMC_NS)
  */

typedef struct {                                /*!< VMC_NS Structure                                                          */
  __IM  uint32_t  RESERVED[384];
  __IOM VMC_RAM_Type RAM[8];                    /*!< Unspecified                                                               */
} NRF_VMC_Type;                                 /*!< Size = 1664 (0x680)                                                       */



/* =========================================================================================================================== */
/* ================                                       CC_HOST_RGF_S                                       ================ */
/* =========================================================================================================================== */


/**
  * @brief CRYPTOCELL HOST_RGF interface (CC_HOST_RGF_S)
  */

typedef struct {                                /*!< CC_HOST_RGF_S Structure                                                   */
  __IM  uint32_t  RESERVED[1678];
  __IOM uint32_t  HOST_CRYPTOKEY_SEL;           /*!< AES hardware key select                                                   */
  __IM  uint32_t  RESERVED1[4];
  __IOM uint32_t  HOST_IOT_KPRTL_LOCK;          /*!< This write-once register is the K_PRTL lock register. When this
                                                     register is set, K_PRTL cannot be used and a zeroed key
                                                     will be used instead. The value of this register is saved
                                                     in the CRYPTOCELL AO power domain.                                        */
  __IOM uint32_t  HOST_IOT_KDR0;                /*!< This register holds bits 31:0 of K_DR. The value of this register
                                                     is saved in the CRYPTOCELL AO power domain. Reading from
                                                     this address returns the K_DR valid status indicating if
                                                     K_DR is successfully retained.                                            */
  __OM  uint32_t  HOST_IOT_KDR1;                /*!< This register holds bits 63:32 of K_DR. The value of this register
                                                     is saved in the CRYPTOCELL AO power domain.                               */
  __OM  uint32_t  HOST_IOT_KDR2;                /*!< This register holds bits 95:64 of K_DR. The value of this register
                                                     is saved in the CRYPTOCELL AO power domain.                               */
  __OM  uint32_t  HOST_IOT_KDR3;                /*!< This register holds bits 127:96 of K_DR. The value of this register
                                                     is saved in the CRYPTOCELL AO power domain.                               */
  __IOM uint32_t  HOST_IOT_LCS;                 /*!< Controls lifecycle state (LCS) for CRYPTOCELL subsystem                   */
} NRF_CC_HOST_RGF_Type;                         /*!< Size = 6756 (0x1a64)                                                      */



/* =========================================================================================================================== */
/* ================                                       CRYPTOCELL_S                                        ================ */
/* =========================================================================================================================== */


/**
  * @brief ARM TrustZone CryptoCell register interface (CRYPTOCELL_S)
  */

typedef struct {                                /*!< CRYPTOCELL_S Structure                                                    */
  __IM  uint32_t  RESERVED[320];
  __IOM uint32_t  ENABLE;                       /*!< Enable CRYPTOCELL subsystem                                               */
} NRF_CRYPTOCELL_Type;                          /*!< Size = 1284 (0x504)                                                       */



/* =========================================================================================================================== */
/* ================                                           P0_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief GPIO Port 0 (P0_NS)
  */

typedef struct {                                /*!< P0_NS Structure                                                           */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  OUT;                          /*!< Write GPIO port                                                           */
  __IOM uint32_t  OUTSET;                       /*!< Set individual bits in GPIO port                                          */
  __IOM uint32_t  OUTCLR;                       /*!< Clear individual bits in GPIO port                                        */
  __IM  uint32_t  IN;                           /*!< Read GPIO port                                                            */
  __IOM uint32_t  DIR;                          /*!< Direction of GPIO pins                                                    */
  __IOM uint32_t  DIRSET;                       /*!< DIR set register                                                          */
  __IOM uint32_t  DIRCLR;                       /*!< DIR clear register                                                        */
  __IOM uint32_t  LATCH;                        /*!< Latch register indicating what GPIO pins that have met the criteria
                                                     set in the PIN_CNF[n].SENSE registers                                     */
  __IOM uint32_t  DETECTMODE;                   /*!< Select between default DETECT signal behavior and LDETECT mode
                                                     (For non-secure pin only)                                                 */
  __IOM uint32_t  DETECTMODE_SEC;               /*!< Select between default DETECT signal behavior and LDETECT mode
                                                     (For secure pin only)                                                     */
  __IM  uint32_t  RESERVED1[117];
  __IOM uint32_t  PIN_CNF[32];                  /*!< Description collection: Configuration of GPIO pins                        */
} NRF_GPIO_Type;                                /*!< Size = 640 (0x280)                                                        */


/** @} */ /* End of group Device_Peripheral_peripherals */


/* =========================================================================================================================== */
/* ================                          Device Specific Peripheral Address Map                           ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripheralAddr
  * @{
  */

#define NRF_FICR_S_BASE             0x00FF0000UL
#define NRF_UICR_S_BASE             0x00FF8000UL
#define NRF_TAD_S_BASE              0xE0080000UL
#define NRF_SPU_S_BASE              0x50003000UL
#define NRF_REGULATORS_NS_BASE      0x40004000UL
#define NRF_REGULATORS_S_BASE       0x50004000UL
#define NRF_CLOCK_NS_BASE           0x40005000UL
#define NRF_POWER_NS_BASE           0x40005000UL
#define NRF_CLOCK_S_BASE            0x50005000UL
#define NRF_POWER_S_BASE            0x50005000UL
#define NRF_CTRL_AP_PERI_S_BASE     0x50006000UL
#define NRF_SPIM0_NS_BASE           0x40008000UL
#define NRF_SPIS0_NS_BASE           0x40008000UL
#define NRF_TWIM0_NS_BASE           0x40008000UL
#define NRF_TWIS0_NS_BASE           0x40008000UL
#define NRF_UARTE0_NS_BASE          0x40008000UL
#define NRF_SPIM0_S_BASE            0x50008000UL
#define NRF_SPIS0_S_BASE            0x50008000UL
#define NRF_TWIM0_S_BASE            0x50008000UL
#define NRF_TWIS0_S_BASE            0x50008000UL
#define NRF_UARTE0_S_BASE           0x50008000UL
#define NRF_SPIM1_NS_BASE           0x40009000UL
#define NRF_SPIS1_NS_BASE           0x40009000UL
#define NRF_TWIM1_NS_BASE           0x40009000UL
#define NRF_TWIS1_NS_BASE           0x40009000UL
#define NRF_UARTE1_NS_BASE          0x40009000UL
#define NRF_SPIM1_S_BASE            0x50009000UL
#define NRF_SPIS1_S_BASE            0x50009000UL
#define NRF_TWIM1_S_BASE            0x50009000UL
#define NRF_TWIS1_S_BASE            0x50009000UL
#define NRF_UARTE1_S_BASE           0x50009000UL
#define NRF_SPIM2_NS_BASE           0x4000A000UL
#define NRF_SPIS2_NS_BASE           0x4000A000UL
#define NRF_TWIM2_NS_BASE           0x4000A000UL
#define NRF_TWIS2_NS_BASE           0x4000A000UL
#define NRF_UARTE2_NS_BASE          0x4000A000UL
#define NRF_SPIM2_S_BASE            0x5000A000UL
#define NRF_SPIS2_S_BASE            0x5000A000UL
#define NRF_TWIM2_S_BASE            0x5000A000UL
#define NRF_TWIS2_S_BASE            0x5000A000UL
#define NRF_UARTE2_S_BASE           0x5000A000UL
#define NRF_SPIM3_NS_BASE           0x4000B000UL
#define NRF_SPIS3_NS_BASE           0x4000B000UL
#define NRF_TWIM3_NS_BASE           0x4000B000UL
#define NRF_TWIS3_NS_BASE           0x4000B000UL
#define NRF_UARTE3_NS_BASE          0x4000B000UL
#define NRF_SPIM3_S_BASE            0x5000B000UL
#define NRF_SPIS3_S_BASE            0x5000B000UL
#define NRF_TWIM3_S_BASE            0x5000B000UL
#define NRF_TWIS3_S_BASE            0x5000B000UL
#define NRF_UARTE3_S_BASE           0x5000B000UL
#define NRF_GPIOTE0_S_BASE          0x5000D000UL
#define NRF_SAADC_NS_BASE           0x4000E000UL
#define NRF_SAADC_S_BASE            0x5000E000UL
#define NRF_TIMER0_NS_BASE          0x4000F000UL
#define NRF_TIMER0_S_BASE           0x5000F000UL
#define NRF_TIMER1_NS_BASE          0x40010000UL
#define NRF_TIMER1_S_BASE           0x50010000UL
#define NRF_TIMER2_NS_BASE          0x40011000UL
#define NRF_TIMER2_S_BASE           0x50011000UL
#define NRF_RTC0_NS_BASE            0x40014000UL
#define NRF_RTC0_S_BASE             0x50014000UL
#define NRF_RTC1_NS_BASE            0x40015000UL
#define NRF_RTC1_S_BASE             0x50015000UL
#define NRF_DPPIC_NS_BASE           0x40017000UL
#define NRF_DPPIC_S_BASE            0x50017000UL
#define NRF_WDT_NS_BASE             0x40018000UL
#define NRF_WDT_S_BASE              0x50018000UL
#define NRF_EGU0_NS_BASE            0x4001B000UL
#define NRF_EGU0_S_BASE             0x5001B000UL
#define NRF_EGU1_NS_BASE            0x4001C000UL
#define NRF_EGU1_S_BASE             0x5001C000UL
#define NRF_EGU2_NS_BASE            0x4001D000UL
#define NRF_EGU2_S_BASE             0x5001D000UL
#define NRF_EGU3_NS_BASE            0x4001E000UL
#define NRF_EGU3_S_BASE             0x5001E000UL
#define NRF_EGU4_NS_BASE            0x4001F000UL
#define NRF_EGU4_S_BASE             0x5001F000UL
#define NRF_EGU5_NS_BASE            0x40020000UL
#define NRF_EGU5_S_BASE             0x50020000UL
#define NRF_PWM0_NS_BASE            0x40021000UL
#define NRF_PWM0_S_BASE             0x50021000UL
#define NRF_PWM1_NS_BASE            0x40022000UL
#define NRF_PWM1_S_BASE             0x50022000UL
#define NRF_PWM2_NS_BASE            0x40023000UL
#define NRF_PWM2_S_BASE             0x50023000UL
#define NRF_PWM3_NS_BASE            0x40024000UL
#define NRF_PWM3_S_BASE             0x50024000UL
#define NRF_PDM_NS_BASE             0x40026000UL
#define NRF_PDM_S_BASE              0x50026000UL
#define NRF_I2S_NS_BASE             0x40028000UL
#define NRF_I2S_S_BASE              0x50028000UL
#define NRF_IPC_NS_BASE             0x4002A000UL
#define NRF_IPC_S_BASE              0x5002A000UL
#define NRF_FPU_NS_BASE             0x4002C000UL
#define NRF_FPU_S_BASE              0x5002C000UL
#define NRF_GPIOTE1_NS_BASE         0x40031000UL
#define NRF_KMU_NS_BASE             0x40039000UL
#define NRF_NVMC_NS_BASE            0x40039000UL
#define NRF_KMU_S_BASE              0x50039000UL
#define NRF_NVMC_S_BASE             0x50039000UL
#define NRF_VMC_NS_BASE             0x4003A000UL
#define NRF_VMC_S_BASE              0x5003A000UL
#define NRF_CC_HOST_RGF_S_BASE      0x50840000UL
#define NRF_CRYPTOCELL_S_BASE       0x50840000UL
#define NRF_P0_NS_BASE              0x40842500UL
#define NRF_P0_S_BASE               0x50842500UL

/** @} */ /* End of group Device_Peripheral_peripheralAddr */


/* =========================================================================================================================== */
/* ================                                  Peripheral declaration                                   ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_declaration
  * @{
  */

#define NRF_FICR_S                  ((NRF_FICR_Type*)          NRF_FICR_S_BASE)
#define NRF_UICR_S                  ((NRF_UICR_Type*)          NRF_UICR_S_BASE)
#define NRF_TAD_S                   ((NRF_TAD_Type*)           NRF_TAD_S_BASE)
#define NRF_SPU_S                   ((NRF_SPU_Type*)           NRF_SPU_S_BASE)
#define NRF_REGULATORS_NS           ((NRF_REGULATORS_Type*)    NRF_REGULATORS_NS_BASE)
#define NRF_REGULATORS_S            ((NRF_REGULATORS_Type*)    NRF_REGULATORS_S_BASE)
#define NRF_CLOCK_NS                ((NRF_CLOCK_Type*)         NRF_CLOCK_NS_BASE)
#define NRF_POWER_NS                ((NRF_POWER_Type*)         NRF_POWER_NS_BASE)
#define NRF_CLOCK_S                 ((NRF_CLOCK_Type*)         NRF_CLOCK_S_BASE)
#define NRF_POWER_S                 ((NRF_POWER_Type*)         NRF_POWER_S_BASE)
#define NRF_CTRL_AP_PERI_S          ((NRF_CTRLAPPERI_Type*)    NRF_CTRL_AP_PERI_S_BASE)
#define NRF_SPIM0_NS                ((NRF_SPIM_Type*)          NRF_SPIM0_NS_BASE)
#define NRF_SPIS0_NS                ((NRF_SPIS_Type*)          NRF_SPIS0_NS_BASE)
#define NRF_TWIM0_NS                ((NRF_TWIM_Type*)          NRF_TWIM0_NS_BASE)
#define NRF_TWIS0_NS                ((NRF_TWIS_Type*)          NRF_TWIS0_NS_BASE)
#define NRF_UARTE0_NS               ((NRF_UARTE_Type*)         NRF_UARTE0_NS_BASE)
#define NRF_SPIM0_S                 ((NRF_SPIM_Type*)          NRF_SPIM0_S_BASE)
#define NRF_SPIS0_S                 ((NRF_SPIS_Type*)          NRF_SPIS0_S_BASE)
#define NRF_TWIM0_S                 ((NRF_TWIM_Type*)          NRF_TWIM0_S_BASE)
#define NRF_TWIS0_S                 ((NRF_TWIS_Type*)          NRF_TWIS0_S_BASE)
#define NRF_UARTE0_S                ((NRF_UARTE_Type*)         NRF_UARTE0_S_BASE)
#define NRF_SPIM1_NS                ((NRF_SPIM_Type*)          NRF_SPIM1_NS_BASE)
#define NRF_SPIS1_NS                ((NRF_SPIS_Type*)          NRF_SPIS1_NS_BASE)
#define NRF_TWIM1_NS                ((NRF_TWIM_Type*)          NRF_TWIM1_NS_BASE)
#define NRF_TWIS1_NS                ((NRF_TWIS_Type*)          NRF_TWIS1_NS_BASE)
#define NRF_UARTE1_NS               ((NRF_UARTE_Type*)         NRF_UARTE1_NS_BASE)
#define NRF_SPIM1_S                 ((NRF_SPIM_Type*)          NRF_SPIM1_S_BASE)
#define NRF_SPIS1_S                 ((NRF_SPIS_Type*)          NRF_SPIS1_S_BASE)
#define NRF_TWIM1_S                 ((NRF_TWIM_Type*)          NRF_TWIM1_S_BASE)
#define NRF_TWIS1_S                 ((NRF_TWIS_Type*)          NRF_TWIS1_S_BASE)
#define NRF_UARTE1_S                ((NRF_UARTE_Type*)         NRF_UARTE1_S_BASE)
#define NRF_SPIM2_NS                ((NRF_SPIM_Type*)          NRF_SPIM2_NS_BASE)
#define NRF_SPIS2_NS                ((NRF_SPIS_Type*)          NRF_SPIS2_NS_BASE)
#define NRF_TWIM2_NS                ((NRF_TWIM_Type*)          NRF_TWIM2_NS_BASE)
#define NRF_TWIS2_NS                ((NRF_TWIS_Type*)          NRF_TWIS2_NS_BASE)
#define NRF_UARTE2_NS               ((NRF_UARTE_Type*)         NRF_UARTE2_NS_BASE)
#define NRF_SPIM2_S                 ((NRF_SPIM_Type*)          NRF_SPIM2_S_BASE)
#define NRF_SPIS2_S                 ((NRF_SPIS_Type*)          NRF_SPIS2_S_BASE)
#define NRF_TWIM2_S                 ((NRF_TWIM_Type*)          NRF_TWIM2_S_BASE)
#define NRF_TWIS2_S                 ((NRF_TWIS_Type*)          NRF_TWIS2_S_BASE)
#define NRF_UARTE2_S                ((NRF_UARTE_Type*)         NRF_UARTE2_S_BASE)
#define NRF_SPIM3_NS                ((NRF_SPIM_Type*)          NRF_SPIM3_NS_BASE)
#define NRF_SPIS3_NS                ((NRF_SPIS_Type*)          NRF_SPIS3_NS_BASE)
#define NRF_TWIM3_NS                ((NRF_TWIM_Type*)          NRF_TWIM3_NS_BASE)
#define NRF_TWIS3_NS                ((NRF_TWIS_Type*)          NRF_TWIS3_NS_BASE)
#define NRF_UARTE3_NS               ((NRF_UARTE_Type*)         NRF_UARTE3_NS_BASE)
#define NRF_SPIM3_S                 ((NRF_SPIM_Type*)          NRF_SPIM3_S_BASE)
#define NRF_SPIS3_S                 ((NRF_SPIS_Type*)          NRF_SPIS3_S_BASE)
#define NRF_TWIM3_S                 ((NRF_TWIM_Type*)          NRF_TWIM3_S_BASE)
#define NRF_TWIS3_S                 ((NRF_TWIS_Type*)          NRF_TWIS3_S_BASE)
#define NRF_UARTE3_S                ((NRF_UARTE_Type*)         NRF_UARTE3_S_BASE)
#define NRF_GPIOTE0_S               ((NRF_GPIOTE_Type*)        NRF_GPIOTE0_S_BASE)
#define NRF_SAADC_NS                ((NRF_SAADC_Type*)         NRF_SAADC_NS_BASE)
#define NRF_SAADC_S                 ((NRF_SAADC_Type*)         NRF_SAADC_S_BASE)
#define NRF_TIMER0_NS               ((NRF_TIMER_Type*)         NRF_TIMER0_NS_BASE)
#define NRF_TIMER0_S                ((NRF_TIMER_Type*)         NRF_TIMER0_S_BASE)
#define NRF_TIMER1_NS               ((NRF_TIMER_Type*)         NRF_TIMER1_NS_BASE)
#define NRF_TIMER1_S                ((NRF_TIMER_Type*)         NRF_TIMER1_S_BASE)
#define NRF_TIMER2_NS               ((NRF_TIMER_Type*)         NRF_TIMER2_NS_BASE)
#define NRF_TIMER2_S                ((NRF_TIMER_Type*)         NRF_TIMER2_S_BASE)
#define NRF_RTC0_NS                 ((NRF_RTC_Type*)           NRF_RTC0_NS_BASE)
#define NRF_RTC0_S                  ((NRF_RTC_Type*)           NRF_RTC0_S_BASE)
#define NRF_RTC1_NS                 ((NRF_RTC_Type*)           NRF_RTC1_NS_BASE)
#define NRF_RTC1_S                  ((NRF_RTC_Type*)           NRF_RTC1_S_BASE)
#define NRF_DPPIC_NS                ((NRF_DPPIC_Type*)         NRF_DPPIC_NS_BASE)
#define NRF_DPPIC_S                 ((NRF_DPPIC_Type*)         NRF_DPPIC_S_BASE)
#define NRF_WDT_NS                  ((NRF_WDT_Type*)           NRF_WDT_NS_BASE)
#define NRF_WDT_S                   ((NRF_WDT_Type*)           NRF_WDT_S_BASE)
#define NRF_EGU0_NS                 ((NRF_EGU_Type*)           NRF_EGU0_NS_BASE)
#define NRF_EGU0_S                  ((NRF_EGU_Type*)           NRF_EGU0_S_BASE)
#define NRF_EGU1_NS                 ((NRF_EGU_Type*)           NRF_EGU1_NS_BASE)
#define NRF_EGU1_S                  ((NRF_EGU_Type*)           NRF_EGU1_S_BASE)
#define NRF_EGU2_NS                 ((NRF_EGU_Type*)           NRF_EGU2_NS_BASE)
#define NRF_EGU2_S                  ((NRF_EGU_Type*)           NRF_EGU2_S_BASE)
#define NRF_EGU3_NS                 ((NRF_EGU_Type*)           NRF_EGU3_NS_BASE)
#define NRF_EGU3_S                  ((NRF_EGU_Type*)           NRF_EGU3_S_BASE)
#define NRF_EGU4_NS                 ((NRF_EGU_Type*)           NRF_EGU4_NS_BASE)
#define NRF_EGU4_S                  ((NRF_EGU_Type*)           NRF_EGU4_S_BASE)
#define NRF_EGU5_NS                 ((NRF_EGU_Type*)           NRF_EGU5_NS_BASE)
#define NRF_EGU5_S                  ((NRF_EGU_Type*)           NRF_EGU5_S_BASE)
#define NRF_PWM0_NS                 ((NRF_PWM_Type*)           NRF_PWM0_NS_BASE)
#define NRF_PWM0_S                  ((NRF_PWM_Type*)           NRF_PWM0_S_BASE)
#define NRF_PWM1_NS                 ((NRF_PWM_Type*)           NRF_PWM1_NS_BASE)
#define NRF_PWM1_S                  ((NRF_PWM_Type*)           NRF_PWM1_S_BASE)
#define NRF_PWM2_NS                 ((NRF_PWM_Type*)           NRF_PWM2_NS_BASE)
#define NRF_PWM2_S                  ((NRF_PWM_Type*)           NRF_PWM2_S_BASE)
#define NRF_PWM3_NS                 ((NRF_PWM_Type*)           NRF_PWM3_NS_BASE)
#define NRF_PWM3_S                  ((NRF_PWM_Type*)           NRF_PWM3_S_BASE)
#define NRF_PDM_NS                  ((NRF_PDM_Type*)           NRF_PDM_NS_BASE)
#define NRF_PDM_S                   ((NRF_PDM_Type*)           NRF_PDM_S_BASE)
#define NRF_I2S_NS                  ((NRF_I2S_Type*)           NRF_I2S_NS_BASE)
#define NRF_I2S_S                   ((NRF_I2S_Type*)           NRF_I2S_S_BASE)
#define NRF_IPC_NS                  ((NRF_IPC_Type*)           NRF_IPC_NS_BASE)
#define NRF_IPC_S                   ((NRF_IPC_Type*)           NRF_IPC_S_BASE)
#define NRF_FPU_NS                  ((NRF_FPU_Type*)           NRF_FPU_NS_BASE)
#define NRF_FPU_S                   ((NRF_FPU_Type*)           NRF_FPU_S_BASE)
#define NRF_GPIOTE1_NS              ((NRF_GPIOTE_Type*)        NRF_GPIOTE1_NS_BASE)
#define NRF_KMU_NS                  ((NRF_KMU_Type*)           NRF_KMU_NS_BASE)
#define NRF_NVMC_NS                 ((NRF_NVMC_Type*)          NRF_NVMC_NS_BASE)
#define NRF_KMU_S                   ((NRF_KMU_Type*)           NRF_KMU_S_BASE)
#define NRF_NVMC_S                  ((NRF_NVMC_Type*)          NRF_NVMC_S_BASE)
#define NRF_VMC_NS                  ((NRF_VMC_Type*)           NRF_VMC_NS_BASE)
#define NRF_VMC_S                   ((NRF_VMC_Type*)           NRF_VMC_S_BASE)
#define NRF_CC_HOST_RGF_S           ((NRF_CC_HOST_RGF_Type*)   NRF_CC_HOST_RGF_S_BASE)
#define NRF_CRYPTOCELL_S            ((NRF_CRYPTOCELL_Type*)    NRF_CRYPTOCELL_S_BASE)
#define NRF_P0_NS                   ((NRF_GPIO_Type*)          NRF_P0_NS_BASE)
#define NRF_P0_S                    ((NRF_GPIO_Type*)          NRF_P0_S_BASE)

/** @} */ /* End of group Device_Peripheral_declaration */


#ifdef __cplusplus
}
#endif

#endif /* NRF9160_H */


/** @} */ /* End of group nrf9160 */

/** @} */ /* End of group Nordic Semiconductor */
